﻿#region

using System;
using System.Drawing;
using System.Linq;
using System.Text;
using McLovin;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Superbad
{
    public partial class Classname : CombatRoutine
    {
        public static string lastlog = "";

        public static void LogAction(string log, int colour)
        {
            var clr = Color.Brown;
            if (colour == 0)
                clr = Color.Red;
            if (colour == 1)
                clr = Color.Yellow;
            if (colour == 2)
                clr = Color.LimeGreen;
            else if (colour > 2)
                clr = Color.DarkOrange;
            if (log == lastlog) return;
            var newColor = System.Windows.Media.Color.FromArgb(clr.A, clr.R, clr.G, clr.B);
            Logging.Write(LogLevel.Normal, newColor, log);
            lastlog = log;
        }


        private static bool auto_attack()
        {
            if (StyxWoW.Me.IsAutoAttacking)
                return false;
            if (target.distance > MeleeRange)
                return false;
            if (StyxWoW.Me.CurrentTarget != null)
            {
                StyxWoW.Me.ToggleAttack();
                return true;
            }
            return false;
        }

        private static bool berserking()
        {
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (StyxWoW.Me.IsInInstance &&
                !target.IsBoss(StyxWoW.Me.CurrentTarget) && !target.IsTrainingDummy(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (StyxWoW.Me.Race == WoWRace.Troll)
                return Spell.Buff("Berserking", true);
            return false;
        }

        private static bool use_item(WoWInventorySlot slot, string explain)
        {
            var item = StyxWoW.Me.Inventory.GetItemBySlot((uint) slot);
            if (item != null)
            {
                var itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);
                if (string.IsNullOrEmpty(itemSpell))
                    return false;
                if (item.Usable && item.Cooldown <= 0)
                {
                    LogAction(item.Name + " " + explain, 2);
                    item.Use();
                    return true;
                }
            }
            return false;
        }


        private static bool use_item()
        {
            var item = StyxWoW.Me.Inventory.GetItemBySlot((uint) WoWInventorySlot.Hands);
            if (item != null)
            {
                var itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);
                if (string.IsNullOrEmpty(itemSpell))
                    return false;
                if (item.Usable && item.Cooldown <= 0)
                {
                    LogAction(item.Name, 2);
                    item.Use();
                    return true;
                }
            }
            return false;
        }

        private static bool Use_Health_Stone()
        {
            var stone = StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 5512);
            if (stone == null)
                return false;
            if (stone.Cooldown == 0)
            {
                stone.Use();
                Logging.Write(LogLevel.Normal, "Using Health Stone");
                return true;
            }
            return false;
        }

        private static bool virmens_bite_potion()
        {
            if (!SuperbadSettings.Instance.UsePotion)
                return false;
            if (target.distance > MeleeRange)
                return false;
            var virmens = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 76089);
            if (virmens == null)
                return false;
            if (virmens.Usable && virmens.Cooldown <= 0)
            {
                LogAction(virmens.Name, 2);
                virmens.Use();
                return true;
            }
            return false;
        }

        private static bool life_spirit()
        {
            if (!SuperbadSettings.Instance.UsePotion)
                return false;
            var spirit = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 89640);
            if (spirit == null)
                return false;
            if (spirit.Usable && spirit.Cooldown <= 0)
            {
                Logging.Write(LogLevel.Normal, "Using item: " + spirit.Name);
                spirit.Use();
                return true;
            }
            return false;
        }


        private static bool trinket1()
        {
            if (SuperbadSettings.Instance.Trinket1Usage == 0)
                return false;
            if (SuperbadSettings.Instance.Trinket1Usage == 1 && debuff.cc.up)
                if (Trinket.UseTrinketOne())
                    return true;
            if (SuperbadSettings.Instance.Trinket1Usage == 2 && buff.tigers_fury.up)
                if (Trinket.UseTrinketOne())
                    return true;
            if (SuperbadSettings.Instance.Trinket1Usage == 3 &&
                StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Trinket1Percent)
                if (Trinket.UseTrinketOne())
                    return true;
            if (SuperbadSettings.Instance.Trinket1Usage == 4)
                if (Trinket.UseTrinketOne())
                    return true;
            return false;
        }

        private static bool trinket2()
        {
            if (SuperbadSettings.Instance.Trinket2Usage == 0)
                return false;
            if (SuperbadSettings.Instance.Trinket2Usage == 1 && debuff.cc.up)
                if (Trinket.UseTrinketTwo())
                    return true;
            if (SuperbadSettings.Instance.Trinket2Usage == 2 && buff.tigers_fury.up)
                if (Trinket.UseTrinketTwo())
                    return true;
            if (SuperbadSettings.Instance.Trinket2Usage == 3 &&
                StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Trinket2Percent)
                if (Trinket.UseTrinketTwo())
                    return true;
            if (SuperbadSettings.Instance.Trinket2Usage == 4)
                if (Trinket.UseTrinketTwo())
                    return true;
            return false;
        }

        private static bool darkflight()
        {
            if (buff.dash.up || buff.stampeding_roar.up)
                return false;
            if (StyxWoW.Me.Race == WoWRace.Worgen && !Spell.DoubleCastEntries.ContainsKey("Speed"))
                if (SpellManager.Spells["Darkflight"].CooldownTimeLeft.TotalSeconds < 1)
                {
                    SpellManager.Cast("Darkflight");
                    Logging.Write(LogLevel.Normal, "Darkflight");
                    Spell.UpdateDoubleCastEntries("Speed", 0.5);
                    return true;
                }
            return false;
        }

        private bool flask()
        {
            var flask = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 75525);
            if (flask == null)
                return false;
            if (flask.Usable && flask.Cooldown <= 0)
            {
                Logging.Write(LogLevel.Normal, "Using item: " + flask.Name);
                flask.Use();
                return true;
            }
            return false;
        }

        private static bool lifeblood()
        {
            return Spell.Buff("Lifeblood", true);
        }

        public static string RealLuaEscape(string luastring)
        {
            var bytes = Encoding.UTF8.GetBytes(luastring);
            return bytes.Aggregate(String.Empty, (current, b) => current + ("\\" + b));
        }

        private static bool blood_fury()
        {
            if (!SpellManager.HasSpell("Blood Fury"))
                return false;
            if (SpellManager.Spells["Blood Fury"].CooldownTimeLeft.TotalSeconds >
                SpellManager.GlobalCooldownLeft.TotalSeconds)
                return false;
            SpellManager.Cast("Blood Fury");
            Logging.Write(LogLevel.Normal, "Blood Fury");
            return true;
        }

        private static bool jade_serpent_potion()
        {
            var jade = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 114757);
            if (jade == null)
                return false;
            if (jade.Usable && jade.Cooldown <= 0)
            {
                Logging.Write(LogLevel.Normal, "Using item: " + jade.Name);
                jade.Use();
                return true;
            }
            return false;
        }
    }
}