﻿#region

using System;
using System.Collections.Generic;
using System.Linq;
using McLovin;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Inventory;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Superbad
{
    public partial class Classname : CombatRoutine
    {
        #region Variables

        /*
            12) stealth in no combat dont work. 
            13) savage roar spam in stealth dont work
         */


        //general variables
        private static double? _rake_tick_multiplier;
        private static double? _rip_tick_multiplier;
        private static double? _rip_remains;
        private static double? _combo_points;
        private static double? _energy;
        private static double? _time_to_max;
        private static double? _EnergyRegen;
        private static double? _cast_time;

        //Debuff
        public static double? _debuff_weakened_armor_stack;

        //target
        public static double? _time_to_die;
        public static double? _pct;

        //Cooldown
        public static double? _cooldown_berserk_remains;
        public static double? _cooldown_tigers_fury_remains;

        //Dot
        public static double? _dot_rake_remains;
        public static bool? _dot_rip_ticking;
        public static double? _dot_rip_remains;
        public static double? _dot_thrash_cat_remains;

        //Buff
        public static bool? _buff_berserk_up;
        public static bool? _buff_berserk_down;
        public static double? _buff_berserk_remains;
        public static bool? _buff_cat_form_down;
        public static bool? _buff_dream_of_cenarius_damage_down;
        public static bool? _buff_dream_of_cenarius_damage_up;
        public static double? _buff_dream_of_cenarius_damage_stack;
        public static double? _buff_heart_of_the_wild_remains;
        public static bool? _buff_heart_of_the_wild_up;
        public static bool? _buff_king_of_the_jungle_up;
        public static bool? _buff_king_of_the_jungle_down;
        public static bool? _buff_natures_swiftness_up;
        public static bool? _buff_natures_vigil_up;
        public static bool? _buff_omen_of_clarity_react;
        public static bool? _buff_predatory_swiftness_up;
        public static bool? _buff_predatory_swiftness_down;
        public static double? _buff_predatory_swiftness_remains;
        public static double? _buff_savage_roar_remains;
        public static bool? _buff_savage_roar_down;
        public static bool? _buff_savage_roar_up;
        public static bool? _buff_tigers_fury_up;
        public static bool? _buff_virmens_bite_potion_up;

        //This values will not be resetted. Its managed by combatlogger.
        public static double _ExtendedRip;
        public static double _dot_rake_multiplier;
        public static double _dot_rip_multiplier;

        public static double _dot_thrash_cat_multiplier;

        //NEW STUFF
        public static double? _rip_ratio;
        public static double? _rake_ratio;
        public static double? _time_til_bitw;
        public static double? _time;
        public static bool? _buff_rune_of_reorigination_up;
        public static double? _buff_rune_of_reorigination_remains;
        public static bool? _dot_rake_ticking;


        //NEWEST STUFF
        public static double? _thrash_cat_tick_multiplier;
        public static double? _buff_tigers_fury_remains;
        public static double? _distance;

        #endregion

        private static bool HandleAoeCombat()
        {
            if (buff.cat_form.down)
                if (cat_form())
                    return true;
            if (auto_attack())
                return true;
            if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 &&
                buff.predatory_swiftness.remains <= 1.5 &&
                buff.dream_of_cenarius_damage.down)
                if (healing_touch())
                    return true;
            if (buff.natures_swiftness.up)
                if (healing_touch())
                    return true;
            //TODO: THIS HAS TO BE A CYCLE!
            if ((time_to_max > 1 && !buff.omen_of_clarity.react) ||
                (time_to_max > 2 && buff.omen_of_clarity.react) && target.time_to_die > 5)
                if (debuff.weakened_armor.stack < 3)
                    if (faerie_firecatcombat())
                        return true;
            if (buff.savage_roar.down || (buff.savage_roar.remains < 3 && combo_points > 0))
                if (savage_roar())
                    return true;
            if (buff.tigers_fury.up)
                if (use_item())
                    return true;
            if (buff.tigers_fury.up)
                if (berserking())
                    return true;
            if (energy <= 35 && !buff.omen_of_clarity.react)
                if (tigers_fury())
                    return true;
            if (buff.tigers_fury.up)
                if (berserk())
                    return true;
            if (buff.rune_of_reorigination.remains < 3 && buff.predatory_swiftness.up &&
                buff.predatory_swiftness.remains > 0.2)
                if (healing_touch())
                    return true;
            if (buff.rune_of_reorigination.remains < 3 && buff.predatory_swiftness.down &&
                buff.dream_of_cenarius_damage.down)
                if (natures_swiftness())
                    return true;
            if (buff.rune_of_reorigination.up &&
                (dot.thrash_cat.multiplier <= thrash_cat_tick_multiplier ||
                 buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 ||
                 cooldown.natures_swiftness.remains == 0))
                if (thrash_cat())
                    return true;
            if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 &&
                (dot.thrash_cat.remains < 5 ||
                 (buff.tigers_fury.remains > 1 && dot.thrash_cat.remains < 9 && energy >= 40)))
                if (healing_touch())
                    return true;
            if (buff.predatory_swiftness.down && buff.dream_of_cenarius_damage.down &&
                (dot.thrash_cat.remains < 5 ||
                 (buff.tigers_fury.remains > 1 && dot.thrash_cat.remains < 9 && energy >= 40)))
                if (natures_swiftness())
                    return true;
            if (buff.tigers_fury.up && dot.thrash_cat.remains < 9)
                if (thrash_cat())
                    return true;
            if (dot.thrash_cat.remains < 3)
                if (thrash_cat())
                    return true;
            if (buff.savage_roar.remains < 9 && combo_points >= 5)
                if (savage_roar())
                    return true;
            if ((Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < 8 || buff.rune_of_reorigination.up))

                if (SuperbadSettings.Instance.RakeCycle)
                {
                    var rake_targets = Unit.NearbyUnfriendlyUnitsWithOutRake;
                    if (rake_targets.Any())
                    {
                        if (rake_cycle(rake_targets.FirstOrDefault()))
                        {
                            return true;
                        }
                    }
                }
            if (buff.savage_roar.remains <= 5)
                if (swipe_cat())
                    return true;
            if ((buff.tigers_fury.up || buff.berserk.up))
                if (swipe_cat())
                    return true;
            if (cooldown.tigers_fury.remains < 3)
                if (swipe_cat())
                    return true;
            if (buff.omen_of_clarity.react)
                if (swipe_cat())
                    return true;
            if (time_to_max <= 1)
                if (swipe_cat())
                    return true;
            return false;
        }


        private static bool Filler()
        {
            if (dot.thrash_cat.remains < 3 && target.time_to_die >= 6 && combo_points >= 5)
                if (thrash_cat())
                    return true;
            if (ravage())
                return true;
            if ((buff.omen_of_clarity.react || buff.berserk.up || EnergyRegen >= 15) && buff.king_of_the_jungle.down)
                if (shred())
                    return true;
            if (buff.king_of_the_jungle.down)
                if (mangle())
                    return true;
            return false;
        }

        private static bool doc()
        {
            if (buff.cat_form.down)
                if (cat_form())
                    return true;
            if (auto_attack())
                return true;
            if (berserking())
                return true;
            if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 &&
                buff.predatory_swiftness.remains <= 1.5 &&
                buff.dream_of_cenarius_damage.down)
                if (healing_touch())
                    return true;
            if (buff.savage_roar.down)
                if (savage_roar())
                    return true;
            if ((time_to_max > 1 && !buff.omen_of_clarity.react) ||
                (time_to_max > 2 && buff.omen_of_clarity.react) && target.time_to_die > 5)
                if (debuff.weakened_armor.stack < 3)
                    if (faerie_firecatcombat())
                        return true;
            if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 && combo_points >= 4 &&
                buff.dream_of_cenarius_damage.stack < 2)
                if (healing_touch())
                    return true;
            if (buff.natures_swiftness.up)
                if (healing_touch())
                    return true;
            if (talent.incarnation.enabled && energy <= 35 && !buff.omen_of_clarity.react &&
                cooldown.tigers_fury.remains == 0 && cooldown.berserk.remains == 0)
                if (incarnation())
                    return true;
            if (buff.tigers_fury.up)
                if (use_item())
                    return true;
            if (buff.tigers_fury.up)
                if (trinket1())
                    return true;
            if (buff.tigers_fury.up)
                if (trinket2())
                    return true;
            if (buff.tigers_fury.up)
                if (lifeblood())
                    return true;
            if ((energy <= 35 && !buff.omen_of_clarity.react) || buff.king_of_the_jungle.up)
                if (tigers_fury())
                    return true;
            if (buff.tigers_fury.up || (target.time_to_die < 18 && cooldown.tigers_fury.remains > 6))
                if (berserk())
                    return true;
            if (combo_points >= 1 && dot.rip.ticking && dot.rip.remains <= 3 && target.health.pct <= 25)
                if (ferocious_bite())
                    return true;
            if (target.time_to_die >= 6 && buff.omen_of_clarity.react && dot.thrash_cat.remains < 3)
                if (thrash_cat())
                    return true;
            if ((target.time_to_die <= 4 && combo_points >= 5) || (target.time_to_die <= 1 && combo_points >= 3))
                if (ferocious_bite())
                    return true;
            if (buff.savage_roar.remains <= 3 && combo_points > 0 && target.health.pct < 25)
                if (savage_roar())
                    return true;
            if ((combo_points >= 5 && (time_til_bitw) < 15 && buff.rune_of_reorigination.up &&
                 buff.dream_of_cenarius_damage.up) || target.time_to_die <= 40)
                if (virmens_bite_potion())
                    return true;
            if (talent.natures_swiftness.enabled && buff.dream_of_cenarius_damage.down &&
                buff.predatory_swiftness.down && combo_points >= 5 && (rip_ratio) >= 0.92 && target.time_to_die > 30)
                if (natures_swiftness())
                    return true;
            if (combo_points >= 5 && (rip_ratio) >= 1.15 && target.time_to_die > 30)
                if (rip())
                    return true;
            if (talent.natures_swiftness.enabled && buff.dream_of_cenarius_damage.down &&
                buff.predatory_swiftness.down && combo_points >= 5 && target.health.pct <= 25)
                if (natures_swiftness())
                    return true;
            if (combo_points >= 5 && dot.rip.ticking && target.health.pct <= 25 &&
                ((energy < 50 && buff.berserk.down) || (energy < 25 && buff.berserk.remains > 1)))
                return true;
            if (combo_points >= 5 && dot.rip.ticking && target.health.pct <= 25)
                if (ferocious_bite())
                    return true;
            if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 2.0 &&
                buff.dream_of_cenarius_damage.up)
                if (rip())
                    return true;
            if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 6.0 &&
                buff.dream_of_cenarius_damage.up && (rip_ratio) >= 1)
                if (rip())
                    return true;
            if (talent.natures_swiftness.enabled && buff.dream_of_cenarius_damage.down &&
                buff.predatory_swiftness.down && combo_points >= 5 && dot.rip.remains < 3 &&
                (buff.berserk.up || dot.rip.remains + 1.9 <= cooldown.tigers_fury.remains) && target.health.pct > 25)
                if (natures_swiftness())
                    return true;
            if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 2.0 &&
                (buff.berserk.up || dot.rip.remains + 1.9 <= cooldown.tigers_fury.remains))
                if (rip())
                    return true;
            if (buff.savage_roar.remains <= 3 && combo_points > 0 && buff.savage_roar.remains + 2 > dot.rip.remains)
                if (savage_roar())
                    return true;
            if (buff.savage_roar.remains <= 6 && combo_points >= 5 && buff.savage_roar.remains + 2 <= (rip_remains) &&
                dot.rip.ticking)
                if (savage_roar())
                    return true;
            if (combo_points >= 5 && ((energy < 50 && buff.berserk.down) || (energy < 25 && buff.berserk.remains > 1)) &&
                dot.rip.ticking && !(dot.rip.remains - 2 <= time_to_max - 1) &&
                !(buff.savage_roar.remains - 3 <= time_to_max - 1) &&
                !((buff.savage_roar.remains - 6 <= time_to_max - 1) && buff.savage_roar.remains + 2 <= (rip_remains)))
                return true;

            if (combo_points >= 5 && dot.rip.ticking && !(dot.rip.remains - 2 <= time_to_max - 1) &&
                !(buff.savage_roar.remains - 3 <= time_to_max - 1) &&
                !((buff.savage_roar.remains - 6 <= time_to_max - 1) && buff.savage_roar.remains + 2 <= (rip_remains)))
                if (ferocious_bite())
                    return true;

            if (SuperbadSettings.Instance.RakeCycle)
            {
                var rakeTargets = Unit.NearbyUnfriendlyUnitsWithOutRake;
                if (rakeTargets.Any())
                {
                    if (rake_cycle(rakeTargets.FirstOrDefault()))
                    {
                        return true;
                    }
                }
            }

            if (rake_tick_multiplier > mangle_calc && rake_tick_multiplier >= dot.rake.multiplier)
            {
                if (rake())
                    return true;
            }
            if (buff.rune_of_reorigination.up && dot.rake.remains < 9 && (buff.rune_of_reorigination.remains <= 1.5))
            {
                if (rake())
                    return true;
            }
            if (target.time_to_die - dot.rake.remains > 3 && dot.rake.remains < 6 &&
                buff.dream_of_cenarius_damage.up && (rake_ratio) >= 1)
            {
                if (rake())
                    return true;
            }
            if (target.time_to_die - dot.rake.remains > 3 && (rake_ratio) > 1.12)
            {
                if (rake())
                    return true;
            }
            if (target.time_to_die - dot.rake.remains > 3 && dot.rake.remains < 3)
            {
                if (rake())
                    return true;
            }
            //TODO: actions.doc+=/pool_resource,wait=0.1,for_next=1
            if (target.time_to_die >= 6 && dot.thrash_cat.remains < 3 && ((rip_remains) >= 4 || buff.berserk.up) &&
                dot.rip.ticking)
                if (thrash_cat())
                    return true;
            if (buff.omen_of_clarity.react)
                if (Filler())
                    return true;
            if (((combo_points < 5 && dot.rip.remains < 3.0) || (combo_points == 0 && buff.savage_roar.remains < 2)))
                if (Filler())
                    return true;
            if (buff.predatory_swiftness.remains > 1)
                if (Filler())
                    return true;
            if (target.time_to_die <= 8.5)
                if (Filler())
                    return true;
            if ((buff.tigers_fury.up || buff.berserk.up || buff.natures_vigil.up))
                if (Filler())
                    return true;
            if (cooldown.tigers_fury.remains <= 3.0)
                if (Filler())
                    return true;
            if (time_to_max <= 1.0)
                if (Filler())
                    return true;
            if (talent.force_of_nature.enabled)
                if (treants())
                    return true;
            if (ghost_wolfes())
                return true;
            return false;
        }

        private static bool nondoc()
        {
            if ((buff.cat_form.down && !SuperbadSettings.Instance.WrathSpam) ||
                (SuperbadSettings.Instance.WrathSpam && !buff.heart_of_the_wild.up))
                if (cat_form())
                    return true;
            if (auto_attack())
                return true;
            if (berserking())
                return true;
            if (buff.heart_of_the_wild.up)
                if (use_item())
                    return true;
            if (talent.heart_of_the_wild.enabled /*&& time < 10*/)
                if (heart_of_the_wild())
                    return true;
            if (buff.heart_of_the_wild.up || target.time_to_die <= 40)
                if (virmens_bite_potion())
                    return true;
            if (cast_time < buff.heart_of_the_wild.remains)
                if (wrath())
                    return true;
            if (buff.cat_form.down && !buff.heart_of_the_wild.up)
                if (cat_form())
                    return true;
            if (buff.savage_roar.down)
                if (savage_roar())
                    return true;
            //TODO: THIS HAS TO BE A CYCLE!
            if ((time_to_max > 1 && !buff.omen_of_clarity.react) ||
                (time_to_max > 2 && buff.omen_of_clarity.react) && target.time_to_die > 5)
                if (debuff.weakened_armor.stack < 3)
                    if (faerie_firecatcombat())
                        return true;
            if (talent.incarnation.enabled && energy <= 35 && !buff.omen_of_clarity.react &&
                cooldown.tigers_fury.remains == 0 && cooldown.berserk.remains == 0)
                if (incarnation())
                    return true;
            if (buff.tigers_fury.up)
                if (use_item())
                    return true;
            if (buff.tigers_fury.up)
                if (trinket1())
                    return true;
            if (buff.tigers_fury.up)
                if (trinket2())
                    return true;
            if (buff.tigers_fury.up)
                if (lifeblood())
                    return true;
            if ((energy <= 35 && !buff.omen_of_clarity.react) || buff.king_of_the_jungle.up)
                if (tigers_fury())
                    return true;
            if (buff.tigers_fury.up || (target.time_to_die < 18 && cooldown.tigers_fury.remains > 6))
                if (berserk())
                    return true;
            if (talent.natures_vigil.enabled &&
                (buff.tigers_fury.up || (target.time_to_die < 35 && cooldown.tigers_fury.remains > 6)))
                if (natures_vigil())
                    return true;
            if (combo_points >= 1 && dot.rip.ticking && dot.rip.remains <= 2 && target.health.pct <= 25)
                if (ferocious_bite())
                    return true;
            if (target.time_to_die >= 6 && buff.omen_of_clarity.react && dot.thrash_cat.remains < 3)
                if (thrash_cat())
                    return true;
            if ((target.time_to_die <= 4 && combo_points >= 5) || (target.time_to_die <= 1 && combo_points >= 3))
                if (ferocious_bite())
                    return true;
            if (buff.savage_roar.remains <= 3 && combo_points > 0 && target.health.pct < 25)
                if (savage_roar())
                    return true;
            if ((combo_points >= 5 && (time_til_bitw) < 15 && buff.rune_of_reorigination.up) ||
                target.time_to_die <= 40)
                if (virmens_bite_potion())
                    return true;
            if (combo_points >= 5 && (rip_ratio) >= 1.15 && target.time_to_die > 30)
                if (rip())
                    return true;
            if (combo_points >= 5 && dot.rip.ticking && target.health.pct <= 25)
                if (ferocious_bite())
                    return true;
            if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 2.0 &&
                (buff.berserk.up || dot.rip.remains + 1.9 <= cooldown.tigers_fury.remains))
                if (rip())
                    return true;
            if (buff.savage_roar.remains <= 3 && combo_points > 0 && buff.savage_roar.remains + 2 > (rip_remains))
                if (savage_roar())
                    return true;
            if (buff.savage_roar.remains <= 6 && combo_points >= 5 && buff.savage_roar.remains + 2 <= (rip_remains))
                if (savage_roar())
                    return true;
            if (combo_points >= 5 && dot.rip.ticking && !(dot.rip.remains - 2 <= time_to_max - 1) &&
                !(buff.savage_roar.remains - 3 <= time_to_max - 1) &&
                !((buff.savage_roar.remains - 6 <= time_to_max - 1) && buff.savage_roar.remains + 2 <= (rip_remains)))
                if (ferocious_bite())
                    return true;

            if (SuperbadSettings.Instance.RakeCycle)
            {
                var rake_targets = Unit.NearbyUnfriendlyUnitsWithOutRake;
                if (rake_targets.Any())
                {
                    if (rake_cycle(rake_targets.FirstOrDefault()))
                    {
                        return true;
                    }
                }
            }

            if (buff.rune_of_reorigination.up && (rake_ratio) >= 1)
            {
                if (rake())
                    return true;
            }
            if (buff.rune_of_reorigination.up && dot.rake.remains < 9 && (buff.rune_of_reorigination.remains <= 1.5))
            {
                if (rake())
                    return true;
            }
            if (target.time_to_die - dot.rake.remains > 3 && (rake_ratio) > 1.12)
            {
                if (rake())
                    return true;
            }
            if (target.time_to_die - dot.rake.remains > 3 && dot.rake.remains < 3.0)
            {
                if (rake())
                    return true;
            }
            //TODO: actions.doc+=/pool_resource,wait=0.1,for_next=1
            if (dot.thrash_cat.remains < 3 && target.time_to_die >= 6 && ((rip_remains) >= 4 || buff.berserk.up))
                if (thrash_cat())
                    return true;
            if (buff.omen_of_clarity.react)
                if (Filler())
                    return true;
            if (((combo_points < 5 && dot.rip.remains < 3.0) || (combo_points == 0 && buff.savage_roar.remains < 2)))
                if (Filler())
                    return true;
            if (target.time_to_die <= 8.5)
                if (Filler())
                    return true;
            if ((buff.tigers_fury.up || buff.berserk.up || buff.natures_vigil.up))
                if (Filler())
                    return true;
            if (cooldown.tigers_fury.remains <= 3.0)
                if (Filler())
                    return true;
            if (time_to_max <= 1.0)
                if (Filler())
                    return true;
            if (talent.soul_of_the_forest.enabled && combo_points < 5)
                if (Filler())
                    return true;
            if (talent.force_of_nature.enabled)
                if (treants())
                    return true;
            if (talent.natures_swiftness.enabled && buff.natures_vigil.up && !buff.predatory_swiftness.up &&
                buff.predatory_swiftness.remains > 0.2)
                if (natures_swiftness())
                    return true;
            if (buff.natures_vigil.up &&
                (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 || buff.natures_swiftness.up) &&
                !buff.berserk.up)
                if (healing_touch())
                    return true;
            if (ghost_wolfes())
                return true;
            return false;
        }

        private static bool HandleSingleTarget()
        {
            if (TalentManager.DreamOfCenarius)
                if (doc())
                    return true;
            if (!TalentManager.DreamOfCenarius)
                if (nondoc())
                    return true;
            return false;
        }

        public static void FeralRotations()
        {
            resetVariables();
            if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 &&
                StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Predatory)
            {
                if (healing_touch())
                    return;
            }
            if (buff.natures_swiftness.up && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Natures)
            {
                if (healing_touch())
                    return;
            }
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.LifeSpirit)
                if (life_spirit())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.HealthStone)
                if (Use_Health_Stone())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Renewal)
                if (renewal())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.CenarionWard)
                if (cenarion_ward())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Barkskin)
                if (Barkskin())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Natures)
            {
                if (natures_swiftness())
                    return;
            }
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Survival)
                if (Survival_Instincts())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.HealingTouchCombat)
                if (healing_touch())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.RejuvenationCombat && !buff.rejuvenation.up)
                if (rejuvenation())
                    return;
            if (SuperbadSettings.Instance.Trinket1Usage != 2)
            {
                if (trinket1())
                    return;
            }
            if (SuperbadSettings.Instance.Trinket1Usage != 2)
            {
                if (trinket2())
                    return;
            }
            if (buff.rooted.up)
                if (escapespeed())
                    return;
            if (buff.rooted.up)
                if (escape())
                    return;
            if (buff.flag.up)
                if (natures_grasp())
                    return;
            if (NeedBear())
            {
                CreateBearRotation();
                return;
            }
            if (NeedCat())
            {
                CreateCatRotation();
                return;
            }
        }

        private static void CreateCatRotation()
        {
            if (rebirth())
                return;
            if (buff.cat_form.down && !TalentManager.DreamOfCenarius)
                if (cat_form())
                    return;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Cat && SuperbadSettings.Instance.Form == 3)
                return;
            if (skull_bash_cat())
                return;
            if (Wild_Charge())
                return;
            if (Displacer_Beast())
                return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (darkflight())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (dash())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (stampeding_roar())
                    return;

            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) >= SuperbadSettings.Instance.CatAOE)
            {
                if (HandleAoeCombat())
                    return;
            }
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < SuperbadSettings.Instance.CatAOE)
            {
                if (HandleSingleTarget())
                    return;
            }
        }

        private static void CreateBearRotation()
        {
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.MightofUrsoc && SuperbadSettings.Instance.Form != 0 &&
                SuperbadSettings.Instance.Form != 3)
                if (Might_of_Ursoc())
                    return;
            if (bear_form())
                return;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Bear && SuperbadSettings.Instance.Form == 3)
                return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Frenzied)
                if (Frenzied_Regeneration())
                    return;
            if (skull_bash_cat())
                return;
            if (Wild_Charge())
                return;
            if (growl())
                return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f &&
                                                     cooldown.wild_charge >= 3))
                if (darkflight())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (stampeding_roar())
                    return;
            //Aoe
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) >= SuperbadSettings.Instance.BearAOE)
            {
                if (StyxWoW.Me.CurrentRage > 80)
                    if (Maul())
                        return;
                if (Mangle())
                    return;
                if (thrash_bear())
                    return;
                {
                    if (Swipe())
                        return;
                }
                if (Lacerate())
                    return;
            }
            //Single Target
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < SuperbadSettings.Instance.BearAOE)
            {
                if (StyxWoW.Me.CurrentRage > 80)
                {
                    if (Maul())
                    {
                    }
                }
                if (Mangle())
                    return;
                if (Lacerate())
                    return;
                if (debuff.weakened_blows.down)
                    if (thrash_bear())
                        return;
                if (dot.thrash_cat.remains > 6)
                {
                    if (faerie_fire())
                        return;
                }
            }
        }

        private static bool NeedCat()
        {
            if (SuperbadSettings.Instance.Form == 1)
                return false;
            if (SuperbadSettings.Instance.Form == 0)
                return true;
            if (SuperbadSettings.Instance.Form == 3 && StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                return true;
            if (StyxWoW.Me.CachedHasAura(106922))
                return false;
            if (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.Frenzied && SuperbadSettings.Instance.Form != 3)
                return false;

            if (SuperbadSettings.Instance.Form == 2 && StyxWoW.Me.IsInInstance &&
                (StyxWoW.Me.HealthPercent > SuperbadSettings.Instance.HealthBearSwitch &&
                 Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < SuperbadSettings.Instance.AddsBearSwitch
                 && !SuperbadSettings.Instance.TurnOffDungeonBear) || SuperbadSettings.Instance.TurnOffDungeonBear)
                return true;
            if (SuperbadSettings.Instance.Form == 2 &&
                StyxWoW.Me.HealthPercent > SuperbadSettings.Instance.HealthBearSwitch &&
                Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < SuperbadSettings.Instance.AddsBearSwitch)
                return true;
            return false;
        }

        private static bool NeedBear()
        {
            if (SuperbadSettings.Instance.Form == 0)
                return false;
            if (SuperbadSettings.Instance.Form == 1)
                return true;
            if (SuperbadSettings.Instance.Form == 3 && StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                return true;
            /*
            if (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.Frenzied && SuperbadSettings.Instance.Form != 3)
                return true;*/
            if (StyxWoW.Me.CachedHasAura(106922))
                return true;
            var map = StyxWoW.Me.CurrentMap;
            if (SuperbadSettings.Instance.Form == 2 &&
                (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.HealthBearSwitch ||
                 Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) >= SuperbadSettings.Instance.AddsBearSwitch)
                && (map.IsBattleground || map.IsArena))
                return true;
            if (SuperbadSettings.Instance.Form == 2 &&
                (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.HealthBearSwitch ||
                 Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) >= SuperbadSettings.Instance.AddsBearSwitch)
                &&
                (StyxWoW.Me.IsInInstance && !SuperbadSettings.Instance.TurnOffDungeonBear || !StyxWoW.Me.IsInInstance))
                return true;
            return false;
        }

        private void FeralPull()
        {
            if (NeedCatPull())
                CatPull();
            if (NeedBearPull())
                BearPull();
        }

        private void BearPull()
        {
            if (buff.bear_form.down)
                if (bear_form())
                    return;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Bear && SuperbadSettings.Instance.Form == 3)
                return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (darkflight())
                    return;
            if (StyxWoW.Me.CurrentTarget != null &&
                (target.distance > MeleeRange + 2f))
                if (stampeding_roar())
                    return;
            if (Wild_Charge())
                return;
            if (Displacer_Beast())
                return;
            {
                if (faerie_fire())
                    return;
            }
            if (auto_attack())
                return;
            if (Mangle())
                return;
        }

        private bool NeedBearPull()
        {
            if (SuperbadSettings.Instance.Form == 0)
                return false;
            if (SuperbadSettings.Instance.Form == 1)
                return true;
            if (SuperbadSettings.Instance.Form == 3 && StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                return true;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Frenzied)
                return true;
            if (StyxWoW.Me.CachedHasAura(106922))
                return true;
            if (SuperbadSettings.Instance.Form == 2 &&
                StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.HealthBearSwitch)
                return true;
            return false;
        }

        private static void CatPull()
        {
            if (buff.cat_form.down)
                if (cat_form())
                    return;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Cat && SuperbadSettings.Instance.Form == 3)
                return;
            if (Unit.IsAboveTheGround(StyxWoW.Me.CurrentTarget))
            {
                if (faerie_fire())
                    return;
            }
            if (Unit.IsAboveTheGround(StyxWoW.Me.CurrentTarget))
            {
                if (moonfire())
                    return;
            }
            if (!buff.prowl.up && SuperbadSettings.Instance.PullStealth)
                if (prowl())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (darkflight())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (dash())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (target.distance > MeleeRange + 2f))
                if (stampeding_roar())
                    return;
            if (Wild_Charge())
                return;
            if (Displacer_Beast())
                return;
            if (buff.prowl.up && SuperbadSettings.Instance.StealthOpener == 1)
            {
                if (StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget))
                {
                    if (ravage())
                        return;
                }
                if (!StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget))
                {
                    Logging.Write("Can't get behind the target, using Pounce instead");
                    if (pounce())
                        return;
                }
            }
            if (buff.prowl.up && SuperbadSettings.Instance.StealthOpener == 0)
                if (pounce())
                    return;
            if (!SuperbadSettings.Instance.PullStealth)
                if (StyxWoW.Me.InLineOfSpellSight)
                    if (faerie_fire())
                        return;
            if (auto_attack())
                return;
            if (Mangle())
                return;
        }

        private bool NeedCatPull()
        {
            if (SuperbadSettings.Instance.Form == 1)
                return false;
            if (SuperbadSettings.Instance.Form == 0)
                return true;
            if (SuperbadSettings.Instance.Form == 3 && StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                return true;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Frenzied)
                return false;
            if (StyxWoW.Me.CachedHasAura(106922))
                return false;
            if (SuperbadSettings.Instance.Form == 2 &&
                StyxWoW.Me.HealthPercent > SuperbadSettings.Instance.HealthBearSwitch)
                return true;
            return false;
        }


        private static void resetVariables()
        {
            _rake_tick_multiplier = null;
            _rip_tick_multiplier = null;
            _rip_remains = null;
            _combo_points = null;
            _energy = null;
            _time_to_max = null;
            _EnergyRegen = null;
            _cast_time = null;
            _debuff_weakened_armor_stack = null;
            _time_to_die = null;
            _pct = null;
            _cooldown_berserk_remains = null;
            _cooldown_tigers_fury_remains = null;
            _dot_rake_remains = null;
            _dot_rip_ticking = null;
            _dot_rip_remains = null;
            _dot_thrash_cat_remains = null;
            _buff_berserk_up = null;
            _buff_berserk_down = null;
            _buff_berserk_remains = null;
            _buff_cat_form_down = null;
            _buff_dream_of_cenarius_damage_down = null;
            _buff_dream_of_cenarius_damage_up = null;
            _buff_dream_of_cenarius_damage_stack = null;
            _buff_heart_of_the_wild_remains = null;
            _buff_heart_of_the_wild_up = null;
            _buff_king_of_the_jungle_up = null;
            _buff_king_of_the_jungle_down = null;
            _buff_natures_swiftness_up = null;
            _buff_natures_vigil_up = null;
            _buff_omen_of_clarity_react = null;
            _buff_predatory_swiftness_up = null;
            _buff_predatory_swiftness_down = null;
            _buff_predatory_swiftness_remains = null;
            _buff_savage_roar_remains = null;
            _buff_savage_roar_down = null;
            _buff_savage_roar_up = null;
            _buff_tigers_fury_up = null;
            _buff_virmens_bite_potion_up = null;
            _rip_ratio = null;
            _rake_ratio = null;
            _time_til_bitw = null;
            _time = null;
            _buff_rune_of_reorigination_up = null;
            _buff_rune_of_reorigination_remains = null;
            _dot_rake_ticking = null;
            _thrash_cat_tick_multiplier = null;
            _buff_tigers_fury_remains = null;
            _distance = null;
        }

        #region Calculations

        private static bool setStartTime;
        private static DateTime StartTime;
        private static TimeSpan inCombat;


        //THESE FORMULAS should be correct now! 26.04.2013
        public static double rip_calclogger
        {
            get
            {
                double mastery = Lua.GetReturnVal<float>("return GetMasteryEffect()", 0)/100;
                return (113 + 300*5 + 0.0484*5*StyxWoW.Me.AttackPower)
                       *8*DamageMultiplier()*(1 + mastery);
            }
        }

        public static double rip_calc
        {
            get
            {
                double mastery = Lua.GetReturnVal<float>("return GetMasteryEffect()", 0)/100;
                return (113 + 300*combo_points + 0.0484*combo_points*StyxWoW.Me.AttackPower)
                       *8*DamageMultiplier()*(1 + mastery);
            }
        }


        public static double rake_calc
        {
            get
            {
                double mastery = Lua.GetReturnVal<float>("return GetMasteryEffect()", 0)/100;
                return ((99 + (StyxWoW.Me.AttackPower*0.3))*DamageMultiplier())*(1 + mastery);
            }
        }

        public static double thrash_cat_calc
        {
            get
            {
                double mastery = Lua.GetReturnVal<float>("return GetMasteryEffect()", 0)/100;
                var bleeddmg = (1232 + 1*StyxWoW.Me.AttackPower*191/1000)*DamageMultiplier()*(1 + mastery);
                var dotdmg = 5*(686 + 1*StyxWoW.Me.AttackPower*141/1000)*DamageMultiplier()*(1 + mastery);
                return bleeddmg + dotdmg;
            }
        }

        public static double mangle_calc
        {
            get
            {
                var mainHand = EquippedItems[InventorySlot.MainHandSlot];

                var dps = mainHand.ItemInfo.DPS;
                var agi = Lua.GetReturnVal<float>("return UnitStat(\"player\",2);", 1);
                var ap = (double) StyxWoW.Me.AttackPower;
                var haste = Lua.GetReturnVal<float>("return GetCombatRating(CR_HASTE_MELEE)", 0)/425.19;
                if (!buff.cat_form.down)
                    ap = ap - (2*agi);
                var findaldps = ((dps + (ap/14))*(1 + haste/100));
                var result = (findaldps*5 + 78)*DamageMultiplier();
                return result;
            }
        }


        private static int NumTier14Pieces
        {
            get
            {
                return
                    StyxWoW.Me.CarriedItems.Count(
                        i =>
                        i.ItemInfo.Id == 86649 || i.ItemInfo.Id == 86650 || i.ItemInfo.Id == 86651 ||
                        i.ItemInfo.Id == 86652 || i.ItemInfo.Id == 86653
                        || i.ItemInfo.Id == 85309 || i.ItemInfo.Id == 85310 || i.ItemInfo.Id == 85311 ||
                        i.ItemInfo.Id == 85312 || i.ItemInfo.Id == 85313
                        || i.ItemInfo.Id == 86923 || i.ItemInfo.Id == 86924 || i.ItemInfo.Id == 86925 ||
                        i.ItemInfo.Id == 86926 || i.ItemInfo.Id == 86927);
            }
        }

        private static bool Has2PieceTier14Bonus
        {
            get { return NumTier14Pieces >= 2; }
        }

        public static Dictionary<InventorySlot, WoWItem> EquippedItems
        {
            get
            {
                var equipped = new Dictionary<InventorySlot, WoWItem>();
                var items = StyxWoW.Me.Inventory.Equipped.Items;

                equipped.Clear();
                for (var i = 0; i < 23; i++)
                    equipped.Add((InventorySlot) (i + 1), items[i]);

                return equipped;
            }
        }


        protected static double rip_tick_multiplier
        {
            get
            {
                if (!_rip_tick_multiplier.HasValue)
                {
                    _rip_tick_multiplier = rip_calc;
                    return _rip_tick_multiplier.Value;
                }
                return _rip_tick_multiplier.Value;
            }
        }

        protected static double thrash_cat_tick_multiplier
        {
            get
            {
                if (!_thrash_cat_tick_multiplier.HasValue)
                {
                    _thrash_cat_tick_multiplier = thrash_cat_calc;
                    return _thrash_cat_tick_multiplier.Value;
                }
                return _thrash_cat_tick_multiplier.Value;
            }
        }

        protected static double rake_tick_multiplier
        {
            get
            {
                if (!_rake_tick_multiplier.HasValue)
                {
                    _rake_tick_multiplier = rake_calc;
                    return _rake_tick_multiplier.Value;
                }
                return _rake_tick_multiplier.Value;
            }
        }

        protected static double rip_ratio
        {
            get
            {
                if (!_rip_ratio.HasValue)
                {
                    if (!dot.rip.ticking)
                    {
                        _rip_ratio = 2;
                        return _rip_ratio.Value;
                    }
                    _rip_ratio = rip_tick_multiplier/dot.rip.multiplier;
                    return _rip_ratio.Value;
                }
                return _rip_ratio.Value;
            }
        }

        protected static double rake_ratio
        {
            get
            {
                if (!_rake_ratio.HasValue)
                {
                    if (!dot.rake.ticking)
                    {
                        _rake_ratio = 2;
                        return _rake_ratio.Value;
                    }
                    _rake_ratio = rake_tick_multiplier/dot.rake.multiplier;
                    return _rake_ratio.Value;
                }
                return _rake_ratio.Value;
            }
        }

        protected static double time_til_bitw
        {
            get
            {
                if (!_time_til_bitw.HasValue)
                {
                    _time_til_bitw = (target.time_to_die*(target.health.pct - 25)/target.health.pct);
                    return _time_til_bitw.Value;
                }
                return _time_til_bitw.Value;
            }
        }

        //TODO:  Implement this time tracker.  
        // Time -> Seconds we are actually in combat.
        protected static double time
        {
            get
            {
                if (!setStartTime)
                {
                    StartTime = DateTime.Now;
                    setStartTime = true;
                }
                if (setStartTime)
                {
                    inCombat = DateTime.Now.Subtract(StartTime);
                }
                return inCombat.TotalSeconds;
            }
        }

        protected static double rip_remains
        {
            get
            {
                if (!_rip_remains.HasValue)
                {
                    if (StyxWoW.Me.CurrentTarget == null)
                    {
                        _rip_remains = 0;
                        return _rip_remains.Value;
                    }
                    if (!StyxWoW.Me.CurrentTarget.HasMyAura("Rip"))
                    {
                        _rip_remains = 0;
                        return _rip_remains.Value;
                    }
                    if (ExtendedRip <= 2)
                        _rip_remains = (dot.rip.remains + (6 - (ExtendedRip*2)));
                    if (ExtendedRip > 2)
                        _rip_remains = (dot.rip.remains);
                    return _rip_remains != null ? _rip_remains.Value : 0;
                }
                return _rip_remains.Value;
            }
        }

        protected static double ExtendedRip
        {
            get { return _ExtendedRip; }
        }

        public static double combo_points
        {
            get
            {
                if (!_combo_points.HasValue)
                {
                    //_combo_points = StyxWoW.Me.ComboPoints;
                    _combo_points = Lua.GetReturnVal<int>("return GetComboPoints(\"player\",\"target\");", 0);
                    return _combo_points.Value;
                }
                return _combo_points.Value;
            }
        }

        protected static double energy
        {
            get
            {
                if (!_energy.HasValue)
                {
                    _energy = Lua.GetReturnVal<int>("return UnitPower(\"player\");", 0);
                    return _energy.Value;
                }
                return _energy.Value;
            }
        }

        protected static double EnergyRegen
        {
            get
            {
                if (!_EnergyRegen.HasValue)
                {
                    _EnergyRegen = Lua.GetReturnVal<float>("return GetPowerRegen()", 1);
                    return _EnergyRegen.Value;
                }
                return _EnergyRegen.Value;
            }
        }

        protected static double time_to_max
        {
            get
            {
                if (!_time_to_max.HasValue)
                {
                    _time_to_max = (100 - energy)*(1.0/EnergyRegen);
                    return _time_to_max.Value;
                }
                return _time_to_max.Value;
            }
        }

        protected static double cast_time
        {
            get
            {
                if (!_cast_time.HasValue)
                {
                    _cast_time = SpellManager.Spells["Wrath"].CastTime*0.001;
                    return _cast_time.Value;
                }
                return _cast_time.Value;
            }
        }

        public static double DamageMultiplier()
        {
            double multiplier = 1;
            //TF
            if (buff.tigers_fury.up)
                multiplier = multiplier*1.15;
            //Savage Roar
            if (buff.savage_roar.up)
                multiplier = multiplier*1.3;
            //Doc
            if (buff.dream_of_cenarius_damage.up)
                multiplier = multiplier*1.25;
            if (buff.natures_vigil.up)
                multiplier = multiplier*1.2;
            return multiplier;
        }

        #endregion
    }


    internal partial class buff
    {
        public class bear_form
        {
            public static bool down
            {
                get { return StyxWoW.Me.Shapeshift != ShapeshiftForm.Bear; }
            }
        }

        public class berserk
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_berserk_up.HasValue)
                    {
                        if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                            Classname._buff_berserk_up = StyxWoW.Me.CachedHasAura(106951);
                        if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                            Classname._buff_berserk_up = StyxWoW.Me.CachedHasAura(50334);
                        return Classname._buff_berserk_up.Value;
                    }
                    return Classname._buff_berserk_up.Value;
                }
            }

            public static bool down
            {
                get
                {
                    if (!Classname._buff_berserk_down.HasValue)
                    {
                        Classname._buff_berserk_down = !StyxWoW.Me.CachedHasAura(106951);
                        return Classname._buff_berserk_down.Value;
                    }
                    return Classname._buff_berserk_down.Value;
                }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._buff_berserk_remains.HasValue)
                    {
                        Classname._buff_berserk_remains = StyxWoW.Me.CachedGetAuraTimeLeft(106951, true);
                        return Classname._buff_berserk_remains.Value;
                    }
                    return Classname._buff_berserk_remains.Value;
                }
            }
        }

        public class cat_form
        {
            public static bool down
            {
                get
                {
                    if (!Classname._buff_cat_form_down.HasValue)
                    {
                        Classname._buff_cat_form_down = StyxWoW.Me.Shapeshift != ShapeshiftForm.Cat;
                        return Classname._buff_cat_form_down.Value;
                    }
                    return Classname._buff_cat_form_down.Value;
                }
            }
        }


        public class dash
        {
            public static bool up
            {
                get { return StyxWoW.Me.CachedHasAura(1850); }
            }
        }


        public class dream_of_cenarius_damage
        {
            public static bool down
            {
                get
                {
                    if (!Classname._buff_dream_of_cenarius_damage_down.HasValue)
                    {
                        Classname._buff_dream_of_cenarius_damage_down = !StyxWoW.Me.CachedHasAura(108381);
                        return Classname._buff_dream_of_cenarius_damage_down.Value;
                    }
                    return Classname._buff_dream_of_cenarius_damage_down.Value;
                }
            }

            public static double stack
            {
                get
                {
                    if (!Classname._buff_dream_of_cenarius_damage_stack.HasValue)
                    {
                        Classname._buff_dream_of_cenarius_damage_stack = StyxWoW.Me.CachedStackCount(108381);
                        return Classname._buff_dream_of_cenarius_damage_stack.Value;
                    }
                    return Classname._buff_dream_of_cenarius_damage_stack.Value;
                }
            }

            public static bool up
            {
                get
                {
                    if (!Classname._buff_dream_of_cenarius_damage_up.HasValue)
                    {
                        Classname._buff_dream_of_cenarius_damage_up = StyxWoW.Me.CachedHasAura(108381);
                        return Classname._buff_dream_of_cenarius_damage_up.Value;
                    }
                    return Classname._buff_dream_of_cenarius_damage_up.Value;
                }
            }
        }

        public class heart_of_the_wild
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_heart_of_the_wild_up.HasValue)
                    {
                        Classname._buff_heart_of_the_wild_up = StyxWoW.Me.CachedHasAura(108292);
                        return Classname._buff_heart_of_the_wild_up.Value;
                    }
                    return Classname._buff_heart_of_the_wild_up.Value;
                }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._buff_heart_of_the_wild_remains.HasValue)
                    {
                        Classname._buff_heart_of_the_wild_remains = StyxWoW.Me.CachedGetAuraTimeLeft(108292, true);
                        return Classname._buff_heart_of_the_wild_remains.Value;
                    }
                    return Classname._buff_heart_of_the_wild_remains.Value;
                }
            }
        }

        public class king_of_the_jungle
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_king_of_the_jungle_up.HasValue)
                    {
                        Classname._buff_king_of_the_jungle_up =
                            StyxWoW.Me.CachedHasAura("Incarnation: King of the Jungle");
                        return Classname._buff_king_of_the_jungle_up.Value;
                    }
                    return Classname._buff_king_of_the_jungle_up.Value;
                }
            }

            public static bool down
            {
                get
                {
                    if (!Classname._buff_king_of_the_jungle_down.HasValue)
                    {
                        Classname._buff_king_of_the_jungle_down =
                            !StyxWoW.Me.CachedHasAura("Incarnation: King of the Jungle");
                        return Classname._buff_king_of_the_jungle_down.Value;
                    }
                    return Classname._buff_king_of_the_jungle_down.Value;
                }
            }
        }

        public class mark_of_the_wild
        {
            public static bool down
            {
                get
                {
                    return !StyxWoW.Me.CachedHasAura("Mark of the Wild") &&
                           !StyxWoW.Me.CachedHasAura("Legacy of the Emperor") &&
                           !StyxWoW.Me.CachedHasAura("Blessing of Kings") &&
                           !StyxWoW.Me.CachedHasAura("Embrace of the Shale Spider");
                }
            }
        }

        public class natures_swiftness
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_natures_swiftness_up.HasValue)
                    {
                        //TODO: CHECK IF THIS WORKS!
                        Classname._buff_natures_swiftness_up = StyxWoW.Me.CachedHasAura(132158);
                        return Classname._buff_natures_swiftness_up.Value;
                    }
                    return Classname._buff_natures_swiftness_up.Value;
                }
            }
        }

        public class natures_vigil
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_natures_vigil_up.HasValue)
                    {
                        Classname._buff_natures_vigil_up = StyxWoW.Me.CachedHasAura(124974);
                        return Classname._buff_natures_vigil_up.Value;
                    }
                    return Classname._buff_natures_vigil_up.Value;
                }
            }
        }

        public class omen_of_clarity
        {
            public static bool react
            {
                get
                {
                    if (!Classname._buff_omen_of_clarity_react.HasValue)
                    {
                        Classname._buff_omen_of_clarity_react = StyxWoW.Me.CachedHasAura(135700);
                        return Classname._buff_omen_of_clarity_react.Value;
                    }
                    return Classname._buff_omen_of_clarity_react.Value;
                }
            }
        }

        public class predatory_swiftness
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_predatory_swiftness_up.HasValue)
                    {
                        Classname._buff_predatory_swiftness_up = StyxWoW.Me.CachedHasAura(69369);
                        return Classname._buff_predatory_swiftness_up.Value;
                    }
                    return Classname._buff_predatory_swiftness_up.Value;
                }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._buff_predatory_swiftness_remains.HasValue)
                    {
                        Classname._buff_predatory_swiftness_remains = Spell.GetAuraTimeLeft(69369);
                        //Classname._buff_predatory_swiftness_remains = StyxWoW.Me.CachedGetAuraTimeLeft(69369, true); 
                        return Classname._buff_predatory_swiftness_remains.Value;
                    }
                    return Classname._buff_predatory_swiftness_remains.Value;
                }
            }

            public static bool down
            {
                get
                {
                    if (!Classname._buff_predatory_swiftness_down.HasValue)
                    {
                        Classname._buff_predatory_swiftness_down = !StyxWoW.Me.CachedHasAura(69369);
                        return Classname._buff_predatory_swiftness_down.Value;
                    }
                    return Classname._buff_predatory_swiftness_down.Value;
                }
            }
        }

        public class prowl
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura("Prowl"); }
            }
        }

        public class rejuvenation
        {
            public static bool up
            {
                get { return StyxWoW.Me.CachedHasAura(774); }
            }
        }

        public class rune_of_reorigination
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_rune_of_reorigination_up.HasValue)
                    {
                        Classname._buff_rune_of_reorigination_up = StyxWoW.Me.CachedHasAura(139116);
                        return Classname._buff_rune_of_reorigination_up.Value;
                    }
                    return Classname._buff_rune_of_reorigination_up.Value;
                }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._buff_rune_of_reorigination_remains.HasValue)
                    {
                        Classname._buff_rune_of_reorigination_remains = StyxWoW.Me.CachedGetAuraTimeLeft(139116, true);
                        return Classname._buff_rune_of_reorigination_remains.Value;
                    }
                    return Classname._buff_rune_of_reorigination_remains.Value;
                }
            }
        }

        public class savage_roar
        {
            public static double remains
            {
                get
                {
                    if (!Classname._buff_savage_roar_remains.HasValue)
                    {
                        Classname._buff_savage_roar_remains = TalentManager.Savagery
                                                                  ? StyxWoW.Me.CachedGetAuraTimeLeft(127538, true)
                                                                  : StyxWoW.Me.CachedGetAuraTimeLeft(52610, true);
                        return Classname._buff_savage_roar_remains.Value;
                    }
                    return Classname._buff_savage_roar_remains.Value;
                }
            }

            public static bool down
            {
                get
                {
                    if (!Classname._buff_savage_roar_down.HasValue)
                    {
                        Classname._buff_savage_roar_down = TalentManager.Savagery
                                                               ? !StyxWoW.Me.CachedHasAura(127538)
                                                               : !StyxWoW.Me.CachedHasAura(52610);
                        return Classname._buff_savage_roar_down.Value;
                    }
                    return Classname._buff_savage_roar_down.Value;
                }
            }

            public static bool up
            {
                get
                {
                    if (!Classname._buff_savage_roar_up.HasValue)
                    {
                        Classname._buff_savage_roar_up = TalentManager.Savagery
                                                             ? StyxWoW.Me.CachedHasAura(127538)
                                                             : StyxWoW.Me.CachedHasAura(52610);
                        return Classname._buff_savage_roar_up.Value;
                    }
                    return Classname._buff_savage_roar_up.Value;
                }
            }
        }

        public class tigers_fury
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_tigers_fury_up.HasValue)
                    {
                        Classname._buff_tigers_fury_up = StyxWoW.Me.CachedHasAura(5217);
                        return Classname._buff_tigers_fury_up.Value;
                    }
                    return Classname._buff_tigers_fury_up.Value;
                }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._buff_tigers_fury_remains.HasValue)
                    {
                        Classname._buff_tigers_fury_remains = StyxWoW.Me.CachedGetAuraTimeLeft(5217, true);
                        return Classname._buff_tigers_fury_remains.Value;
                    }
                    return Classname._buff_tigers_fury_remains.Value;
                }
            }
        }

        public class virmens_bite_potion
        {
            public static bool up
            {
                get
                {
                    if (!Classname._buff_virmens_bite_potion_up.HasValue)
                    {
                        Classname._buff_virmens_bite_potion_up = StyxWoW.Me.CachedHasAura(105697);
                        return Classname._buff_virmens_bite_potion_up.Value;
                    }
                    return Classname._buff_virmens_bite_potion_up.Value;
                }
            }
        }

        #region Nested type: stampede

        public class stampede
        {
            public static bool up
            {
                get { return StyxWoW.Me.CachedHasAura(81022); }
            }
        }

        #endregion

        #region Nested type: stampeding_roar

        public class stampeding_roar
        {
            public static bool up
            {
                get { return StyxWoW.Me.CachedHasAura(77764); }
            }
        }

        #endregion
    }

    internal partial class dot
    {
        public class rake
        {
            public static double remains
            {
                get
                {
                    if (!Classname._dot_rake_remains.HasValue)
                    {
                        Classname._dot_rake_remains = StyxWoW.Me.CurrentTarget.CachedGetAuraTimeLeft("Rake", true);
                        return Classname._dot_rake_remains.Value;
                    }
                    return Classname._dot_rake_remains.Value;
                }
            }

            public static double multiplier
            {
                get { return Classname._dot_rake_multiplier; }
            }

            public static bool ticking
            {
                get
                {
                    if (!Classname._dot_rake_ticking.HasValue)
                    {
                        Classname._dot_rake_ticking = StyxWoW.Me.CurrentTarget != null &&
                                                      StyxWoW.Me.CurrentTarget.HasMyAura("Rake");
                        return Classname._dot_rake_ticking.Value;
                    }
                    return Classname._dot_rake_ticking.Value;
                }
            }

            public static double remains_cycle(WoWUnit woWUnit)
            {
                return woWUnit.CachedGetAuraTimeLeft("Rake", true);
            }
        }

        public class rip
        {
            public static bool ticking
            {
                get
                {
                    if (!Classname._dot_rip_ticking.HasValue)
                    {
                        Classname._dot_rip_ticking = StyxWoW.Me.CurrentTarget != null &&
                                                     StyxWoW.Me.CurrentTarget.HasMyAura("Rip");
                        return Classname._dot_rip_ticking.Value;
                    }
                    return Classname._dot_rip_ticking.Value;
                }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._dot_rip_remains.HasValue)
                    {
                        Classname._dot_rip_remains = StyxWoW.Me.CurrentTarget.CachedGetAuraTimeLeft("Rip", true);
                        return Classname._dot_rip_remains.Value;
                    }
                    return Classname._dot_rip_remains.Value;
                }
            }

            public static double multiplier
            {
                get { return !ticking ? 0 : Classname._dot_rip_multiplier; }
            }
        }

        public class thrash_cat
        {
            public static bool ticking
            {
                get { return StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.HasMyAura("Thrash"); }
            }

            public static double remains
            {
                get
                {
                    if (!Classname._dot_thrash_cat_remains.HasValue)
                    {
                        Classname._dot_thrash_cat_remains = StyxWoW.Me.CurrentTarget.CachedGetAuraTimeLeft("Thrash",
                                                                                                           true);
                        return Classname._dot_thrash_cat_remains.Value;
                    }
                    return Classname._dot_thrash_cat_remains.Value;
                }
            }

            public static double multiplier
            {
                get { return !ticking ? 0 : Classname._dot_thrash_cat_multiplier; }
            }
        }
    }

    internal partial class cooldown
    {
        public class FF
        {
            public static double remains
            {
                get { return Spell.GetSpellCooldown("Faerie Fire").TotalSeconds; }
            }
        }

        public class berserk
        {
            public static double remains
            {
                get
                {
                    if (!Classname._cooldown_berserk_remains.HasValue)
                    {
                        Classname._cooldown_berserk_remains = Spell.GetSpellCooldown("Berserk").TotalSeconds;
                        return Classname._cooldown_berserk_remains.Value;
                    }
                    return Classname._cooldown_berserk_remains.Value;
                }
            }
        }

        public class lacerate
        {
            public static double remains
            {
                get { return Spell.GetSpellCooldown("Lacerate").TotalSeconds; }
            }
        }

        public class natures_swiftness
        {
            public static double remains
            {
                get { return Spell.GetSpellCooldown("Nature's Swiftness").TotalSeconds; }
            }
        }

        public class swipe
        {
            public static double remains
            {
                get { return Spell.GetSpellCooldown("Swipe").TotalSeconds; }
            }
        }

        public class thrash
        {
            public static double remains
            {
                get { return Spell.GetSpellCooldown("Thrash").TotalSeconds; }
            }
        }

        public class tigers_fury
        {
            public static double remains
            {
                get
                {
                    if (!Classname._cooldown_tigers_fury_remains.HasValue)
                    {
                        Classname._cooldown_tigers_fury_remains =
                            Spell.GetSpellCooldown("Tiger's Fury").TotalSeconds;
                        return Classname._cooldown_tigers_fury_remains.Value;
                    }
                    return Classname._cooldown_tigers_fury_remains.Value;
                }
            }
        }
    }

    internal partial class target
    {
        public static double distance
        {
            get
            {
                if (!Classname._distance.HasValue)
                {
                    if (StyxWoW.Me.CurrentTarget != null)
                    {
                        Classname._distance = StyxWoW.Me.CurrentTarget.Distance;
                        return Classname._distance.Value;
                    }
                    return 70;
                }
                return Classname._distance.Value;
            }
        }

        public static double time_to_die
        {
            get
            {
                if (!Classname._time_to_die.HasValue)
                {
                    if (StyxWoW.Me.CurrentTarget != null)
                    {
                        Classname._time_to_die = DpsMeter.GetCombatTimeLeft(StyxWoW.Me.CurrentTarget).TotalSeconds;
                        return Classname._time_to_die.Value;
                    }
                    return 10;
                }
                return Classname._time_to_die.Value;
            }
        }

        public static double time_to_die_circle(WoWUnit unit)
        {
            return unit != null ? DpsMeter.GetCombatTimeLeft(unit).TotalSeconds : 0;
        }

        public class health
        {
            public static double pct
            {
                get
                {
                    if (!Classname._pct.HasValue)
                    {
                        if (StyxWoW.Me.CurrentTarget == null)
                        {
                            Classname._pct = 0;
                            return Classname._pct.Value;
                        }
                        Classname._pct = StyxWoW.Me.CurrentTarget.HealthPercent;
                        return Classname._pct.Value;
                    }
                    return Classname._pct.Value;
                }
            }
        }
    }

    internal partial class debuff
    {
        public class weakened_armor
        {
            public static double stack
            {
                get
                {
                    if (!Classname._debuff_weakened_armor_stack.HasValue)
                    {
                        Classname._debuff_weakened_armor_stack =
                            StyxWoW.Me.CurrentTarget.CachedStackCount("Weakened Armor", true);
                        if (Classname._debuff_weakened_armor_stack == 0 &&
                            StyxWoW.Me.CurrentTarget.CachedHasAura("Weakened Armor"))
                            Classname._debuff_weakened_armor_stack = 3;
                        return Classname._debuff_weakened_armor_stack.Value;
                    }
                    return Classname._debuff_weakened_armor_stack.Value;
                }
            }
        }
    }

    internal partial class talent
    {
        public class dream_of_cenarius
        {
            public static bool enabled
            {
                get { return TalentManager.DreamOfCenarius; }
            }
        }

        public class force_of_nature
        {
            public static bool enabled
            {
                get { return TalentManager.ForceOfNature; }
            }
        }

        public class heart_of_the_wild
        {
            public static bool enabled
            {
                get { return TalentManager.HeartOfTheWild; }
            }
        }

        public class incarnation
        {
            public static bool enabled
            {
                get { return TalentManager.Incarnation; }
            }
        }

        public class natures_swiftness
        {
            public static bool enabled
            {
                get { return TalentManager.NaturesSwiftness; }
            }
        }

        public class natures_vigil
        {
            public static bool enabled
            {
                get { return TalentManager.NaturesVigil; }
            }
        }

        public class soul_of_the_forest
        {
            public static bool enabled
            {
                get { return TalentManager.SoulOfTheForest; }
            }
        }
    }
}