﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Styx.Common;

namespace Superbad
{
    public partial class SuperbadConfig : Form
    {
        public SuperbadConfig()
        {
            InitializeComponent();
        }

        private void Feral_Load(object sender, EventArgs e)
        {
            if (SuperbadSettings.Instance.Form == 0)
                radioButton1.Select();
            if (SuperbadSettings.Instance.Form == 1)
                radioButton2.Select();
            if (SuperbadSettings.Instance.Form == 2)
                radioButton4.Select();
            if (SuperbadSettings.Instance.Form == 3)
                radioButton3.Select();
            numericUpDown1.Value = SuperbadSettings.Instance.AddsBearSwitch;
            numericUpDown2.Value = SuperbadSettings.Instance.HealthBearSwitch;
            checkBox1.Checked = SuperbadSettings.Instance.UseMovement;
            checkBox2.Checked = SuperbadSettings.Instance.UseTargeting;
            checkBox3.Checked = SuperbadSettings.Instance.UseInterrupts;
            checkBox4.Checked = SuperbadSettings.Instance.UsePotion;
            checkBox6.Checked = SuperbadSettings.Instance.UseBlink;
            checkBox5.Checked = SuperbadSettings.Instance.UseStealth;
            numericUpDown3.Value = SuperbadSettings.Instance.Barkskin;
            numericUpDown4.Value = SuperbadSettings.Instance.Frenzied;
            numericUpDown5.Value = SuperbadSettings.Instance.MightofUrsoc;
            numericUpDown6.Value = SuperbadSettings.Instance.Natures;
            numericUpDown7.Value = SuperbadSettings.Instance.Survival;
            checkBox7.Checked = SuperbadSettings.Instance.UseBerserk;
            checkBox8.Checked = SuperbadSettings.Instance.UseTaunt;
            numericUpDown8.Value = SuperbadSettings.Instance.Predatory;
            checkBox9.Checked = SuperbadSettings.Instance.TurnOffDungeonBear;
            checkBox10.Checked = SuperbadSettings.Instance.Mdw;
            checkBox11.Checked = SuperbadSettings.Instance.Mdwgroup;
            checkBox12.Checked = SuperbadSettings.Instance.WaitSickness;
            numericUpDown9.Value = SuperbadSettings.Instance.RestHealth;
            numericUpDown10.Value = SuperbadSettings.Instance.RestMana;
            checkBox13.Checked = SuperbadSettings.Instance.UseSpeedBoost;
            checkBox14.Checked = SuperbadSettings.Instance.StayInStealth;
            numericUpDown11.Value = SuperbadSettings.Instance.Renewal;
            numericUpDown12.Value = SuperbadSettings.Instance.CenarionWard;
            numericUpDown13.Value = SuperbadSettings.Instance.OoCHealingTouch;
            numericUpDown14.Value = SuperbadSettings.Instance.OoCReju;
            checkBox15.Checked = SuperbadSettings.Instance.MightyBash;
            checkBox16.Checked = SuperbadSettings.Instance.Rooted;
            if (SuperbadSettings.Instance.Trinket1Usage == 0)
                radioButton5.Select();
            if (SuperbadSettings.Instance.Trinket1Usage == 1)
                radioButton6.Select();
            if (SuperbadSettings.Instance.Trinket1Usage == 2)
                radioButton7.Select();
            if (SuperbadSettings.Instance.Trinket1Usage == 3)
                radioButton8.Select();
            if (SuperbadSettings.Instance.Trinket1Usage == 4)
                radioButton20.Select();
            numericUpDown15.Value = SuperbadSettings.Instance.Trinket1Percent;
            if (SuperbadSettings.Instance.Trinket2Usage == 0)
                radioButton12.Select();
            if (SuperbadSettings.Instance.Trinket2Usage == 1)
                radioButton11.Select();
            if (SuperbadSettings.Instance.Trinket2Usage == 2)
                radioButton10.Select();
            if (SuperbadSettings.Instance.Trinket2Usage == 3)
                radioButton9.Select();
            if (SuperbadSettings.Instance.Trinket2Usage == 4)
                radioButton21.Select();
            numericUpDown16.Value = SuperbadSettings.Instance.Trinket2Percent;
            numericUpDown17.Value = SuperbadSettings.Instance.HealthStone;
            if(SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.None)
                radioButton13.Select();
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.LSHIFT)
                radioButton14.Select();
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.RSHIFT)
                radioButton15.Select();
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.LCTRL)
                radioButton16.Select();
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.RCTRL)
                radioButton17.Select();
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.LALT)
                radioButton18.Select();
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.RALT)
                radioButton19.Select();
            checkBox17.Checked = SuperbadSettings.Instance.RootedSpeed;
            numericUpDown18.Value = SuperbadSettings.Instance.CatAOE;
            numericUpDown19.Value = SuperbadSettings.Instance.BearAOE;
            checkBox18.Checked = SuperbadSettings.Instance.PrintMsg;
            checkBox19.Checked = SuperbadSettings.Instance.useHotW;
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
                SuperbadSettings.Instance.Form = 0;
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked)
                SuperbadSettings.Instance.Form = 1;
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked)
                SuperbadSettings.Instance.Form = 2;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked)
                SuperbadSettings.Instance.Form = 3;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.AddsBearSwitch = (int) numericUpDown1.Value;
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.HealthBearSwitch = (int)numericUpDown2.Value;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseMovement = checkBox1.Checked;
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseTargeting = checkBox2.Checked;
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseInterrupts = checkBox3.Checked;
        }

        private void checkBox4_CheckedChanged_1(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UsePotion = checkBox4.Checked;
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseBlink = checkBox6.Checked;
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseStealth = checkBox5.Checked;
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Barkskin = (int)numericUpDown3.Value;
        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Frenzied = (int)numericUpDown4.Value;
        }

        private void numericUpDown5_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.MightofUrsoc = (int)numericUpDown5.Value;
        }

        private void numericUpDown6_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Natures = (int)numericUpDown6.Value;
        }

        private void numericUpDown7_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Survival = (int)numericUpDown7.Value;
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseBerserk = checkBox7.Checked;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseTaunt = checkBox8.Checked;
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.TurnOffDungeonBear = checkBox9.Checked;
        }

        private void numericUpDown8_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Predatory = (int) numericUpDown8.Value;
        }

        private void checkBox11_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Mdwgroup = checkBox11.Checked;
        }

        private void checkBox10_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Mdw = checkBox10.Checked;
        }

        private void checkBox12_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.WaitSickness = checkBox12.Checked;
        }

        private void numericUpDown9_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RestHealth = (int) numericUpDown9.Value;
        }

        private void numericUpDown10_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RestMana = (int) numericUpDown10.Value;
        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseSpeedBoost = checkBox13.Checked;
        }

        private void checkBox14_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.StayInStealth = checkBox14.Checked;
        }

        private void numericUpDown11_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Renewal = (int) numericUpDown11.Value;
        }

        private void numericUpDown12_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.CenarionWard = (int) numericUpDown12.Value;
        }

        private void numericUpDown13_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.OoCHealingTouch = (int) numericUpDown13.Value;
        }

        private void numericUpDown14_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.OoCReju = (int) numericUpDown14.Value;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void checkBox15_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.MightyBash = checkBox15.Checked;
        }

        private void checkBox16_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Rooted = checkBox16.Checked;
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked)
                SuperbadSettings.Instance.Trinket1Usage = 0;
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton6.Checked)
                SuperbadSettings.Instance.Trinket1Usage = 1;
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton7.Checked)
                SuperbadSettings.Instance.Trinket1Usage = 2;
        }

        private void radioButton8_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton8.Checked)
                SuperbadSettings.Instance.Trinket1Usage = 3;
        }

        private void numericUpDown15_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Trinket1Percent = (int) numericUpDown15.Value;
        }

        private void radioButton12_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton12.Checked)
                SuperbadSettings.Instance.Trinket2Usage = 0;
        }

        private void radioButton11_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton11.Checked)
                SuperbadSettings.Instance.Trinket2Usage = 1;
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton10.Checked)
                SuperbadSettings.Instance.Trinket2Usage = 2;
        }

        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton9.Checked)
                SuperbadSettings.Instance.Trinket2Usage = 3;
        }

        private void numericUpDown16_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Trinket2Percent = (int)numericUpDown16.Value;
        }

        private void numericUpDown17_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.HealthStone = (int) numericUpDown17.Value;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void radioButton13_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton13.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.None;
        }

        private void radioButton14_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton14.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.LSHIFT;
        }

        private void radioButton15_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton15.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.RSHIFT;
        }

        private void radioButton16_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton16.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.LCTRL;
        }

        private void radioButton17_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton17.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.RCTRL;
        }

        private void radioButton18_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton18.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.LALT;
        }

        private void radioButton19_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton19.Checked)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.RALT;
        }

        private void checkBox17_CheckedChanged(object sender, EventArgs e)
        {
          SuperbadSettings.Instance.RootedSpeed = checkBox17.Checked;
        }

        private void numericUpDown18_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.CatAOE = (int) numericUpDown18.Value;
        }

        private void numericUpDown19_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.BearAOE = (int)numericUpDown19.Value;
        }

        private void radioButton20_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton20.Checked)
                SuperbadSettings.Instance.Trinket1Usage = 4;
        }

        private void radioButton21_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton21.Checked)
                SuperbadSettings.Instance.Trinket2Usage = 4;
        }

        private void checkBox18_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.PrintMsg = checkBox18.Checked;
        }

        private void checkBox19_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.useHotW = checkBox19.Checked;
        }
    }
}
