﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Styx.Common;
using Superbad;

namespace McLovin
{
    public partial class newSuperbadConfig : Form
    {
        public newSuperbadConfig()
        {
            InitializeComponent();
        }

        private void newSuperbadConfig_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = SuperbadSettings.Instance.Form;
            numericUpDown1.Value = SuperbadSettings.Instance.AddsBearSwitch;
            numericUpDown2.Value = SuperbadSettings.Instance.HealthBearSwitch;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.None)
                comboBox2.SelectedIndex = 0;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.LSHIFT)
                comboBox2.SelectedIndex = 1;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.RSHIFT)
                comboBox2.SelectedIndex = 2;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.LCTRL)
                comboBox2.SelectedIndex = 3;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.RCTRL)
                comboBox2.SelectedIndex = 4;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.LALT)
                comboBox2.SelectedIndex = 5;
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.RALT)
                comboBox2.SelectedIndex = 6;
            checkBox1.Checked = SuperbadSettings.Instance.PrintMsg;
            numericUpDown3.Value = SuperbadSettings.Instance.Trinket1Percent;
            numericUpDown4.Value = SuperbadSettings.Instance.Trinket2Percent;
            comboBox6.SelectedIndex = SuperbadSettings.Instance.Trinket1Usage;
            comboBox7.SelectedIndex = SuperbadSettings.Instance.Trinket2Usage;
            checkBox2.Checked = SuperbadSettings.Instance.UseMovement;
            checkBox3.Checked = SuperbadSettings.Instance.UseTargeting;
            numericUpDown18.Value = SuperbadSettings.Instance.CatAOE;
            numericUpDown19.Value = SuperbadSettings.Instance.BearAOE;
            checkBox10.Checked = SuperbadSettings.Instance.Mdw;
            checkBox11.Checked = SuperbadSettings.Instance.Mdwgroup;
            checkBox12.Checked = SuperbadSettings.Instance.WaitSickness;
            numericUpDown9.Value = SuperbadSettings.Instance.RestHealth;
            numericUpDown10.Value = SuperbadSettings.Instance.RestMana;
            checkBox4.Checked = SuperbadSettings.Instance.UseInterrupts;
            checkBox5.Checked = SuperbadSettings.Instance.MightyBash;
            checkBox6.Checked = SuperbadSettings.Instance.UseBlink;
            checkBox7.Checked = SuperbadSettings.Instance.UseBerserk;
            checkBox8.Checked = SuperbadSettings.Instance.useHotW;
            checkBox9.Checked = SuperbadSettings.Instance.UseTaunt;
            checkBox13.Checked = SuperbadSettings.Instance.UseSavageDefense;
            checkBox14.Checked = SuperbadSettings.Instance.UseFrenziedRegen;
            checkBox15.Checked = SuperbadSettings.Instance.UseDash;
            checkBox16.Checked = SuperbadSettings.Instance.RootedSpeed;
            checkBox17.Checked = SuperbadSettings.Instance.Rooted;
            numericUpDown14.Value = SuperbadSettings.Instance.Barkskin;
            numericUpDown13.Value = SuperbadSettings.Instance.Frenzied;
            numericUpDown5.Value = SuperbadSettings.Instance.MightofUrsoc;
            numericUpDown6.Value = SuperbadSettings.Instance.Natures;
            numericUpDown11.Value = SuperbadSettings.Instance.Renewal;
            numericUpDown12.Value = SuperbadSettings.Instance.CenarionWard;
            numericUpDown7.Value = SuperbadSettings.Instance.Survival;
            numericUpDown8.Value = SuperbadSettings.Instance.Predatory;
            numericUpDown17.Value = SuperbadSettings.Instance.HealthStone;
            numericUpDown16.Value = SuperbadSettings.Instance.OoCHealingTouch;
            numericUpDown15.Value = SuperbadSettings.Instance.OoCReju;
            numericUpDown20.Value = SuperbadSettings.Instance.LifeSpirit;
            checkBox18.Checked = SuperbadSettings.Instance.StayInStealth;
            checkBox19.Checked = SuperbadSettings.Instance.SavageFarm;
            checkBox20.Checked = SuperbadSettings.Instance.UsePotion;
            checkBox21.Checked = SuperbadSettings.Instance.Wolves;
            checkBox22.Checked = SuperbadSettings.Instance.HealOthers;
            checkBox23.Checked = SuperbadSettings.Instance.RakeCycle;
            checkBox24.Checked = SuperbadSettings.Instance.UseFFF;
            checkBox25.Checked = SuperbadSettings.Instance.PullStealth;
            checkBox27.Checked = SuperbadSettings.Instance.UseStampedingRoar;
            checkBox26.Checked = SuperbadSettings.Instance.UseNaturesSwiftness;
            checkBox28.Checked =SuperbadSettings.Instance.UseRebirth;
            if (SuperbadSettings.Instance.StealthOpener == 1)
                radioButton2.Select();
            if (SuperbadSettings.Instance.StealthOpener == 0)
                radioButton1.Select();
            if (SuperbadSettings.Instance.RebirthMode == 0)
                radioButton3.Select();
            if (SuperbadSettings.Instance.RebirthMode == 1)
                radioButton4.Select();
            if (SuperbadSettings.Instance.RebirthMode == 2)
                radioButton5.Select();
            if (SuperbadSettings.Instance.RebirthMode == 3)
                radioButton6.Select();
            numericUpDown21.Value = SuperbadSettings.Instance.HealingTouchCombat;
            numericUpDown22.Value = SuperbadSettings.Instance.RejuvenationCombat;
            checkBox29.Checked = SuperbadSettings.Instance.WrathSpam;
        }



        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Form = comboBox1.SelectedIndex;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.AddsBearSwitch = (int) numericUpDown1.Value;
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.HealthBearSwitch = (int) numericUpDown2.Value;
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.None;
            if (comboBox2.SelectedIndex == 1)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.LSHIFT;
            if (comboBox2.SelectedIndex == 2)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.RSHIFT;
            if (comboBox2.SelectedIndex == 3)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.LCTRL;
            if (comboBox2.SelectedIndex == 4)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.RCTRL;
            if (comboBox2.SelectedIndex == 5)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.LALT;
            if (comboBox2.SelectedIndex == 6)
                SuperbadSettings.Instance.PauseKey = SuperbadSettings.Keypress.RALT;
        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void comboBox4_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void comboBox5_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.PrintMsg = checkBox1.Checked;
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Trinket1Percent = (int) numericUpDown3.Value;
        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Trinket2Percent = (int)numericUpDown4.Value;
        }

        private void comboBox6_SelectedIndexChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Trinket1Usage = comboBox6.SelectedIndex;
        }

        private void comboBox7_SelectedIndexChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Trinket2Usage = comboBox7.SelectedIndex;
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseMovement = checkBox2.Checked;
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseTargeting = checkBox3.Checked;
        }

        private void numericUpDown18_ValueChanged_1(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.CatAOE = (int)numericUpDown18.Value;
        }

        private void numericUpDown19_ValueChanged_1(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.BearAOE = (int)numericUpDown19.Value;
        }

        private void checkBox10_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Mdw = checkBox10.Checked;
        }

        private void checkBox11_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Mdwgroup = checkBox11.Checked;
        }

        private void checkBox12_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.WaitSickness = checkBox12.Checked;
        }

        private void numericUpDown9_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RestHealth = (int) numericUpDown9.Value;
        }

        private void numericUpDown10_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RestMana = (int)numericUpDown10.Value;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseInterrupts = checkBox4.Checked;
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.MightyBash = checkBox5.Checked;
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseBlink = checkBox6.Checked;
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseBerserk = checkBox7.Checked;
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.useHotW = checkBox8.Checked;
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseTaunt = checkBox9.Checked;
        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseSavageDefense = checkBox13.Checked;
        }

        private void checkBox14_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseFrenziedRegen = checkBox14.Checked;
        }

        private void checkBox15_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseDash = checkBox15.Checked;
        }

        private void checkBox16_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RootedSpeed = checkBox16.Checked;
        }

        private void checkBox17_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Rooted = checkBox17.Checked;
        }

        private void numericUpDown14_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Barkskin = (int) numericUpDown14.Value;
        }

        private void numericUpDown13_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Frenzied = (int)numericUpDown13.Value;
        }

        private void numericUpDown5_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.MightofUrsoc = (int)numericUpDown5.Value;
        }

        private void numericUpDown6_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Natures = (int)numericUpDown6.Value;
        }

        private void numericUpDown11_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Renewal = (int)numericUpDown11.Value;
        }

        private void numericUpDown12_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.CenarionWard = (int)numericUpDown12.Value;
        }

        private void numericUpDown7_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Survival = (int)numericUpDown7.Value;
        }

        private void numericUpDown8_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Predatory = (int)numericUpDown8.Value;
        }

        private void numericUpDown17_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.HealthStone = (int)numericUpDown17.Value;
        }

        private void numericUpDown16_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.OoCHealingTouch = (int)numericUpDown16.Value;
        }

        private void numericUpDown15_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.OoCReju = (int)numericUpDown15.Value;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void numericUpDown20_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.LifeSpirit = (int) numericUpDown20.Value;
        }

        private void checkBox18_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.StayInStealth = checkBox18.Checked;
        }

        private void checkBox19_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.SavageFarm = checkBox19.Checked;
        }

        private void checkBox20_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UsePotion = checkBox20.Checked;
        }

        private void checkBox21_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Wolves = checkBox21.Checked;
        }

        private void checkBox22_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.HealOthers = checkBox22.Checked;
        }

        private void checkBox23_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RakeCycle = checkBox23.Checked;
        }

        private void checkBox24_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseFFF = checkBox24.Checked;
        }

        private void checkBox25_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.PullStealth = checkBox25.Checked;
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
                SuperbadSettings.Instance.StealthOpener = 0;
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked)
                SuperbadSettings.Instance.StealthOpener = 1;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.Save();
            Logging.Write("Config saved!");
            Close();
        }

        private void checkBox20_CheckedChanged_1(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UsePotion = checkBox20.Checked;
        }

        private void checkBox27_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseStampedingRoar = checkBox27.Checked;
        }

        private void checkBox26_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseNaturesSwiftness = checkBox26.Checked;
        }

        private void checkBox28_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.UseRebirth = checkBox28.Checked;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked)
                SuperbadSettings.Instance.RebirthMode = 0;
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked)
                SuperbadSettings.Instance.RebirthMode = 1;
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked)
                SuperbadSettings.Instance.RebirthMode = 2;
        }

        private void numericUpDown21_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.HealingTouchCombat = (int) numericUpDown21.Value;
        }

        private void numericUpDown22_ValueChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.RejuvenationCombat = (int)numericUpDown22.Value;
        }

        private void checkBox29_CheckedChanged(object sender, EventArgs e)
        {
            SuperbadSettings.Instance.WrathSpam = checkBox29.Checked;
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton6.Checked)
                SuperbadSettings.Instance.RebirthMode = 3;
        }
    }
}
