﻿#region

using System.Linq;
using McLovin;
using Styx;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;

#endregion

namespace Superbad
{
    public partial class Classname : CombatRoutine
    {
        public static void GuardianRotations()
        {
            if (buff.natures_swiftness.up && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Natures)
            {
                if (healing_touch())
                    return;
            }
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.HealthStone)
                if (Use_Health_Stone())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.LifeSpirit)
                if (life_spirit())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Renewal)
                if (renewal())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.CenarionWard)
                if (cenarion_ward())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Barkskin)
                if (Barkskin())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Natures)
            {
                if (natures_swiftness())
                    return;
            }
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Survival)
                if (Survival_Instincts())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.HealingTouchCombat)
                if (healing_touch())
                    return;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.RejuvenationCombat && !buff.rejuvenation.up)
                if (rejuvenation())
                    return;
            {
                if (trinket1())
                    return;
            }
            {
                if (trinket2())
                    return;
            }
            if (buff.rooted.up)
                if (escapespeed())
                    return;
            if (buff.rooted.up)
                if (escape())
                    return;
            if (NeedBear())
            {
                CreateGuardianBearRotation();
                return;
            }
            if (NeedCat())
            {
                CreateGuardianCatRotation();
                return;
            }
        }

        private static bool ThrashAoe()
        {
            if (buff.bear_form.down)
                if (bear_form())
                    return true;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.MightofUrsoc && SuperbadSettings.Instance.Form != 0 &&
                SuperbadSettings.Instance.Form != 3)
                if (Might_of_Ursoc())
                    return true;
            if (!buff.bear_form.down && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.CenarionWard)
                if (cenarion_ward())
                    return true;
            if ((calcFrenziedheal()/2 >= healthMissing()) && StyxWoW.Me.CurrentRage > 89 &&
                StyxWoW.Me.CachedHasAura(135286) && !StyxWoW.Me.CachedHasAura(62606) &&
                !StyxWoW.Me.CachedHasAura(132402))
                if (Maul())
                    return true;
            if ((calcFrenziedheal()/2 < healthMissing()) && StyxWoW.Me.CurrentRage > 80 &&
                (StyxWoW.Me.CachedHasAura(62606) || StyxWoW.Me.CachedHasAura(132402)))
                if (Frenzied_Regeneration())
                    return true;
            if (StyxWoW.Me.CurrentRage > 59 && !StyxWoW.Me.CachedHasAura(62606) && !StyxWoW.Me.CachedHasAura(132402))
                if (savage_defense())
                    return true;
            if (StyxWoW.Me.CurrentRage < 80)
                if (enrage())
                    return true;
            if (SuperbadSettings.Instance.UseBerserk)
                if (berserk())
                    return true;
            if (talent.incarnation.enabled && cooldown.berserk.remains < 170 && cooldown.berserk.remains >= 30)
                if (incarnation())
                    return true;
            if (talent.natures_vigil.enabled)
                if (buff.berserk.up || cooldown.berserk.remains >= 85)
                    if (natures_vigil())
                        return true;
            if (Mangle())
                return true;
            if (thrash_bear())
                return true;
            if (Swipe())
                return true;
            //TODO: KEYPRESS ONLY!
            /*if (StyxWoW.Me.CurrentRage > 59 && !StyxWoW.Me.CachedHasAura(124769))
                if (Frenzied_Regeneration())
                    return true;*/
            if (Lacerate())
                return true;
            if (faerie_fire())
                return true;
            return false;
        }

        private static double calcFrenziedheal()
        {
            var stamina = Lua.GetReturnVal<float>("return UnitStat(\"player\",3);", 1);
            var agi = Lua.GetReturnVal<float>("return UnitStat(\"player\",2);", 1);

            double var1 = (StyxWoW.Me.AttackPower - agi*2);
            var var2 = stamina*2.5;

            return var1 > var2 ? var1 : var2;
        }

        private static double healthMissing()
        {
            return StyxWoW.Me.MaxHealth - StyxWoW.Me.CurrentHealth;
        }

        private static bool SD()
        {
            if (buff.bear_form.down)
                if (bear_form())
                    return true;
            if ((calcFrenziedheal()/2 >= healthMissing()) && StyxWoW.Me.CurrentRage > 89 &&
                StyxWoW.Me.CachedHasAura(135286) &&
                (StyxWoW.Me.CachedHasAura(62606) || StyxWoW.Me.CachedHasAura(132402)))
                if (Maul())
                    return true;
            if ((calcFrenziedheal()/2 < healthMissing()) && StyxWoW.Me.CurrentRage > 80 &&
                (StyxWoW.Me.CachedHasAura(62606) || StyxWoW.Me.CachedHasAura(132402)))
                if (Frenzied_Regeneration())
                    return true;
            if (StyxWoW.Me.CurrentRage > 59 && !StyxWoW.Me.CachedHasAura(62606) && !StyxWoW.Me.CachedHasAura(132402))
                if (savage_defense())
                    return true;
            if (SuperbadSettings.Instance.UseBerserk)
                if (berserk())
                    return true;
            if (talent.incarnation.enabled && cooldown.berserk.remains < 170 && cooldown.berserk.remains >= 30)
                if (incarnation())
                    return true;
            if (talent.natures_vigil.enabled)
                if (buff.berserk.up || cooldown.berserk.remains >= 85)
                    if (natures_vigil())
                        return true;
            //TODO: KEYPRESS ONLY!
            /*if (StyxWoW.Me.CurrentRage > 59 && !StyxWoW.Me.CachedHasAura(124769))
                if (Frenzied_Regeneration())
                    return true;*/
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.MightofUrsoc && SuperbadSettings.Instance.Form != 0 &&
                SuperbadSettings.Instance.Form != 3)
                if (Might_of_Ursoc())
                    return true;
            if (!buff.bear_form.down && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.CenarionWard)
                if (cenarion_ward())
                    return true;
            if (StyxWoW.Me.CurrentRage < 80)
                if (enrage())
                    return true;
            if (Mangle())
                return true;
            if (Lacerate())
                return true;
            if (debuff.weakened_blows.remains < 6)
                if (thrash_bear())
                    return true;
            if (faerie_fire())
                return true;
            if (cooldown.thrash.remains > 1 && cooldown.FF.remains > 1 && cooldown.lacerate.remains > 1 &&
                cooldown.swipe.remains < 1)
                if (Swipe())
                    return true;
            return false;
        }

        private static bool FR()
        {
            if (buff.bear_form.down)
                if (bear_form())
                    return true;
            //TODO: KEYPRESS ONLY!
            //if (Maul()) //keypress override
            //    return true;
            if (StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.MightofUrsoc && SuperbadSettings.Instance.Form != 0 &&
                SuperbadSettings.Instance.Form != 3)
                if (Might_of_Ursoc())
                    return true;
            if (!buff.bear_form.down && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.CenarionWard)
                if (cenarion_ward())
                    return true;
            if (StyxWoW.Me.CurrentRage < 80)
                if (enrage())
                    return true;
            if (Mangle())
                return true;
            if (Lacerate())
                return true;
            if (faerie_fire())
                return true;
            if (thrash_bear())
                return true;
            if (cooldown.thrash.remains > 1 && cooldown.FF.remains > 1 && cooldown.lacerate.remains > 1)
                if (Swipe())
                    return true;
            if (StyxWoW.Me.CurrentRage > 90)
                if (savage_defense())
                    return true;
            if (!TalentManager.FrenziedRegeneration)
                if (StyxWoW.Me.CurrentRage > 59 && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Frenzied)
                    if (Frenzied_Regeneration())
                        return true;
            if (TalentManager.FrenziedRegeneration)
                if (StyxWoW.Me.CurrentRage > 59 && StyxWoW.Me.HealthPercent < SuperbadSettings.Instance.Frenzied &&
                    !StyxWoW.Me.CachedHasAura(54810))
                    if (Frenzied_Regeneration())
                        return true;
            return false;
        }


        private static void CreateGuardianBearRotation()
        {
            if (buff.bear_form.down)
                if (bear_form())
                    return;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Bear && SuperbadSettings.Instance.Form == 3)
                return;
            if (skull_bash_cat())
                return;
            if (Wild_Charge())
                return;
            if (growl())
                return;
            if (StyxWoW.Me.CurrentTarget != null && (StyxWoW.Me.CurrentTarget.Distance > MeleeRange + 2f &&
                                                     !buff.stampeding_roar.up))
                if (darkflight())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (StyxWoW.Me.CurrentTarget.Distance > MeleeRange + 2f &&
                                                     !buff.darkflight.up))
                if (stampeding_roar())
                    return;
            //Aoe
            resetVariables();
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) >= SuperbadSettings.Instance.BearAOE)
            {
                if (ThrashAoe())
                    return;
            }
            //Single Target
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < SuperbadSettings.Instance.BearAOE)
            {
                //if(FR())
                //   return;
                if (SD())
                    return;
            }
        }

        private static void CreateGuardianCatRotation()
        {
            if (buff.cat_form.down)
                if (cat_form())
                    return;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Cat && SuperbadSettings.Instance.Form == 3)
                return;
            if (Wild_Charge())
                return;
            if (Displacer_Beast())
                return;
            if (StyxWoW.Me.CurrentTarget != null && (StyxWoW.Me.CurrentTarget.Distance > MeleeRange + 2f &&
                                                     !buff.stampeding_roar.up && !buff.dash.up))
                if (darkflight())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (StyxWoW.Me.CurrentTarget.Distance > MeleeRange + 2f &&
                                                     !buff.stampeding_roar.up && !buff.darkflight.up))
                if (dash())
                    return;
            if (StyxWoW.Me.CurrentTarget != null && (StyxWoW.Me.CurrentTarget.Distance > MeleeRange + 2f &&
                                                     !buff.dash.up && !buff.darkflight.up))
                if (stampeding_roar())
                    return;
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) >= SuperbadSettings.Instance.CatAOE)
            {
                if (auto_attack())
                    return;
                {
                    if (berserking())
                        return;
                }
                if (skull_bash_cat())
                    return;
                {
                    if (berserk())
                        return;
                }
                if (dot.thrash_cat.remains < 3 && target.time_to_die > 6)
                {
                    if (thrash_cat_guardian())
                        return;
                }
                {
                    if (Swipe())
                        return;
                }
            }

            if (Unit.NearbyUnfriendlyUnits.Count(u => u.Distance < 8) < SuperbadSettings.Instance.CatAOE)
            {
                if (auto_attack())
                    return;
                {
                    if (berserking())
                        return;
                }
                if (buff.heart_of_the_wild.up)
                {
                    if (use_item())
                        return;
                }
                {
                    if (talent.heart_of_the_wild.enabled)
                        if (heart_of_the_wild())
                            return;
                }
                if (buff.heart_of_the_wild.up || target.time_to_die <= 40)
                {
                    if (virmens_bite_potion())
                        return;
                }
                if (cast_time < buff.heart_of_the_wild.remains)
                {
                    if (wrath())
                        return;
                }
                if (buff.cat_form.down)
                    if (cat_form())
                        return;
                if (skull_bash_cat())
                    return;
                if (talent.dream_of_cenarius.enabled && buff.natures_swiftness.up)
                {
                    if (healing_touch())
                        return;
                }
                if (buff.berserk.up)
                {
                    if (use_item())
                        return;
                }
                if (target.time_to_die > 15)
                {
                    if (berserk())
                        return;
                }
                if (buff.berserk.up && talent.natures_vigil.enabled)
                {
                    if (natures_vigil())
                        return;
                }
                if (combo_points >= 1 && dot.rip.ticking && dot.rip.remains <= 2 && target.health.pct <= 25)
                {
                    if (ferocious_bite())
                        return;
                }
                if (debuff.weakened_armor.stack < 3)
                {
                    if (faerie_fire())
                        return;
                }
                if (talent.dream_of_cenarius.enabled && buff.dream_of_cenarius_damage.down && combo_points >= 5 &&
                    target.health.pct <= 25)
                {
                    if (natures_swiftness())
                        return;
                }
                if ((talent.dream_of_cenarius.enabled && combo_points >= 5 && target.health.pct <= 25 &&
                     buff.dream_of_cenarius_damage.up) ||
                    (!talent.dream_of_cenarius.enabled && buff.berserk.up && target.health.pct <= 25) ||
                    target.time_to_die <= 40)
                {
                    if (virmens_bite_potion())
                        return;
                }
                if (combo_points >= 5 && buff.virmens_bite_potion.up && buff.dream_of_cenarius_damage.up &&
                    rip_ratio > 1 && target.health.pct <= 25 && target.time_to_die > 30)
                {
                    if (rip())
                        return;
                }
                if (combo_points >= 5 && rip_ratio > 1.14 && target.health.pct <= 25 &&
                    target.time_to_die > 30)
                {
                    if (rip())
                        return;
                }
                if (combo_points >= 5 && dot.rip.ticking && target.health.pct <= 25)
                {
                    if (ferocious_bite())
                        return;
                }
                if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 2.0 &&
                    buff.dream_of_cenarius_damage.up)
                {
                    if (rip())
                        return;
                }
                if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 6.0 &&
                    buff.dream_of_cenarius_damage.up && rip_ratio > 1 &&
                    target.health.pct > 25)
                {
                    if (rip())
                        return;
                }
                if (talent.dream_of_cenarius.enabled && buff.dream_of_cenarius_damage.down && combo_points >= 5 &&
                    dot.rip.remains < 3 && buff.berserk.up && target.health.pct > 25)
                {
                    if (natures_swiftness())
                        return;
                }
                if (combo_points >= 5 && target.time_to_die >= 6 && dot.rip.remains < 2.0)
                {
                    if (rip())
                        return;
                }
                if ((target.time_to_die <= 4 && combo_points >= 5) || target.time_to_die <= 1)
                {
                    if (ferocious_bite())
                        return;
                }
                if (combo_points >= 5 && rip_remains > 6 && dot.rip.ticking &&
                    (talent.soul_of_the_forest.enabled || buff.berserk.up))
                {
                    if (ferocious_bite())
                        return;
                }
                if (combo_points >= 5 && rip_remains > 10 && dot.rip.ticking)
                {
                    if (ferocious_bite())
                        return;
                }
                if (target.time_to_die >= 8.5 && dot.rake.remains < 6.0 && buff.dream_of_cenarius_damage.up &&
                    rake_ratio > 1)
                {
                    if (rake())
                        return;
                }
                if (target.time_to_die >= 8.5 && rake_ratio > 1.12)
                {
                    if (rake())
                        return;
                }
                if (target.time_to_die >= 8.5 && dot.rake.remains < 3.0 &&
                    (buff.berserk.up || energy > 34))
                {
                    if (rake())
                        return;
                }
                if (((combo_points < 5 && dot.rip.remains < 3.0)))
                {
                    if (ravage())
                        return;
                }
                if (target.time_to_die <= 8.5)
                {
                    if (ravage())
                        return;
                }
                if (((combo_points < 5 && dot.rip.remains < 3.0)))
                {
                    if (shred())
                        return;
                }
                if (target.time_to_die <= 8.5)
                {
                    if (shred())
                        return;
                }
                if (combo_points >= 5 && dot.thrash_cat.remains < 6 && buff.berserk.up)
                {
                    if (thrash_cat_guardian())
                        return;
                }
                if (combo_points >= 5 && dot.thrash_cat.remains < 6 && time_to_max <= 1.0)
                {
                    if (thrash_cat_guardian())
                        return;
                }
                if (buff.berserk.up)
                {
                    if (ravage())
                        return;
                }
                if (time_to_max <= 1.0)
                {
                    if (ravage())
                        return;
                }
                if (buff.berserk.up)
                {
                    if (shred())
                        return;
                }
                if (time_to_max <= 1.0)
                {
                    if (shred())
                        return;
                }
                if (talent.force_of_nature.enabled)
                {
                    if (treants())
                        return;
                }
            }
        }

        private void GuardianPull()
        {
            if (NeedCatPull())
                CatPull();
            if (NeedBearPull())
                BearPull();
        }
    }
}