﻿#region

using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Superbad
{
    internal class Trinket
    {
        public static bool UseTrinketOne()
        {
            if (CheckTrinketOne() && StyxWoW.Me.Inventory.Equipped.Trinket1.Cooldown == 0)
            {
                StyxWoW.Me.Inventory.Equipped.Trinket1.Use();
                Classname.LogAction(StyxWoW.Me.Inventory.Equipped.Trinket1.Name, 2);
                return true;
            }
            return false;
        }

        private static bool CheckTrinketOne()
        {
            if (StyxWoW.Me.Inventory.Equipped.Trinket1 != null)
            {
                if (CanUseEquippedItem(StyxWoW.Me.Inventory.Equipped.Trinket1))
                {
                    return true;
                }
                return false;
            }
            return false;
        }

        public static bool UseTrinketTwo()
        {
            if (CheckTrinketTwo() && StyxWoW.Me.Inventory.Equipped.Trinket2.Cooldown == 0)
            {
                StyxWoW.Me.Inventory.Equipped.Trinket1.Use();
                Classname.LogAction(StyxWoW.Me.Inventory.Equipped.Trinket2.Name, 2);
                return true;
            }
            return false;
        }

        private static bool CheckTrinketTwo()
        {
            if (StyxWoW.Me.Inventory.Equipped.Trinket2 != null)
            {
                if (CanUseEquippedItem(StyxWoW.Me.Inventory.Equipped.Trinket2))
                {
                    return true;
                }
                return false;
            }
            return false;
        }

        private static bool CanUseEquippedItem(WoWItem item)
        {
            // Check for engineering tinkers!
            var itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);
            if (string.IsNullOrEmpty(itemSpell))
                return false;
            return item.Usable && item.Cooldown <= 0;
        }
    }
}