﻿#region

using System.Collections.Generic;
using System.Linq;
using McLovin;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Superbad
{
    internal partial class buff
    {
        #region Nested type: alchemists_flask

        public class alchemists_flask
        {
            public static bool up
            {
                get
                {
                    var flask = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 75525);
                    if (flask == null)
                        return true;
                    if (StyxWoW.Me.HasAura(79638) || StyxWoW.Me.HasAura(79639) || StyxWoW.Me.HasAura(79640))
                        return true;
                    return false;
                }
            }
        }

        #endregion

        #region Nested type: alter_time

        public class alter_time
        {
            public static bool down
            {
                get { return !StyxWoW.Me.HasAura(110909); }
            }

            public static bool up
            {
                get { return StyxWoW.Me.HasAura(110909); }
            }

            public static double remains
            {
                get
                {
                    return StyxWoW.Me.HasAura(110909)
                               ? StyxWoW.Me.GetAuraById(110909).TimeLeft.TotalSeconds
                               : 0;
                }
            }
        }

        #endregion

        #region Nested type: bloodlust

        public class bloodlust
        {
            public static bool react
            {
                get
                {
                    return StyxWoW.Me.HasAura("Bloodlust") || StyxWoW.Me.HasAura("Heroism") ||
                           StyxWoW.Me.HasAura("Time Warp") || StyxWoW.Me.HasAura("Ancient Hysteria");
                }
            }
        }

        #endregion

        #region Nested type: brain_freeze

        public class brain_freeze
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura("Brain Freeze"); }
            }

            public static bool react
            {
                get { return StyxWoW.Me.HasAura("Brain Freeze"); }
            }
        }

        #endregion

        #region Nested type: darkflight

        public class darkflight
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(68992); }
            }
        }

        #endregion

        #region Nested type: fingers_of_frost

        public class fingers_of_frost
        {
            public static double stack
            {
                get
                {
                    return StyxWoW.Me.HasAura("Fingers of Frost")
                               ? StyxWoW.Me.GetAuraByName("Fingers of Frost").StackCount
                               : 0;
                }
            }

            public static bool react
            {
                get { return StyxWoW.Me.HasAura("Fingers of Frost"); }
            }

            public static double remains
            {
                get
                {
                    return StyxWoW.Me.HasAura("Fingers of Frost")
                               ? StyxWoW.Me.GetAuraByName("Fingers of Frost").TimeLeft.TotalSeconds
                               : 0;
                }
            }

            public static bool up
            {
                get { return StyxWoW.Me.HasAura("Fingers of Frost"); }
            }
        }

        #endregion

        #region Nested type: flag

        public class flag
        {
            public static bool up
            {
                get { return StyxWoW.Me.CachedHasAura("Alliance Flag") || StyxWoW.Me.CachedHasAura("Horde Flag"); }
            }
        }

        #endregion

        #region Nested type: icy_veins

        public class icy_veins
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura("Icy Veins"); }
            }
        }

        #endregion

        #region Nested type: invocation

        public class invocation
        {
            public static double remains
            {
                get
                {
                    return StyxWoW.Me.HasAura("Invoker's Energy")
                               ? StyxWoW.Me.GetAuraByName("Invoker's Energy").TimeLeft.TotalSeconds
                               : 0;
                }
            }

            public static bool down
            {
                get { return !StyxWoW.Me.ActiveAuras.ContainsKey("Invoker's Energy"); }
            }
        }

        #endregion

        #region Nested type: master_of_subtlety

        public class master_of_subtlety
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(31665); }
            }
        }

        #endregion

        #region Nested type: presence_of_mind

        public class presence_of_mind
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(12043); }
            }
        }

        #endregion

        #region Nested type: resurrection_sickness

        public class resurrection_sickness
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura("Resurrection Sickness"); }
            }
        }

        #endregion

        public class arcane_charge
        {
            public static double stack
            {
                get { return StyxWoW.Me.HasAura(36032) ? StyxWoW.Me.GetAuraById(36032).StackCount : 0; }
            }

            public static bool up
            {
                get { return StyxWoW.Me.HasAura(36032); }
            }

            public static double remains
            {
                get { return StyxWoW.Me.HasAura(36032) ? StyxWoW.Me.GetAuraById(36032).TimeLeft.TotalSeconds : 0; }
            }
        }

        public class arcane_missiles
        {
            public static double stack
            {
                get { return StyxWoW.Me.HasAura(79683) ? StyxWoW.Me.GetAuraById(79683).StackCount : 0; }
            }

            public static bool react
            {
                get { return StyxWoW.Me.HasAura(79683); }
            }

            public static bool down
            {
                get { return !StyxWoW.Me.HasAura(79683); }
            }
        }

        public class arcane_power
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(12042); }
            }

            public static bool down
            {
                get { return !StyxWoW.Me.HasAura(12042); }
            }
        }

        public class ice_block
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(45438); }
            }
        }

        public class rooted
        {
            public static bool up
            {
                get
                {
                    using (StyxWoW.Memory.AcquireFrame())
                    {
                        if (StyxWoW.Me.Auras.Any(
                            a => DebuffRootHS.Contains(a.Value.SpellId)))
                        {
                            return true;
                        }
                        return false;
                    }
                }
            }
        }

        public class rune_of_power
        {
            public static double remains
            {
                get { return StyxWoW.Me.HasAura(116014) ? Classname.RuneTimer.TimeLeft.TotalSeconds : 0; }
            }

            public static bool down
            {
                get { return !StyxWoW.Me.HasAura(116014); }
            }
        }

        #region DebuffRoot

        private static readonly HashSet<int> DebuffRootHS = new HashSet<int>
            {
                96294, //Chains of Ice (Chilblains)
                116706, //Disable
                64695, //Earthgrab (Earthgrab Totem)
                339, //Entangling Roots
                113770, //Entangling Roots (Force of Nature - Balance Treants)
                19975, //Entangling Roots (Nature's Grasp)
                113275, //Entangling Roots (Symbiosis)
                113275, //Entangling Roots (Symbiosis)
                19185, //Entrapment
                33395, //Freeze
                63685, //Freeze (Frozen Power)
                39965, //Frost Grenade
                122, //Frost Nova
                110693, //Frost Nova (Mage)
                55536, //Frostweave Net
                87194, //Glyph of Mind Blast
                111340, //Ice Ward
                45334, //Immobilized (Wild Charge - Bear)
                90327, //Lock Jaw (Dog)
                102359, //Mass Entanglement
                128405, //Narrow Escape
                13099, //Net-o-Matic
                115197, //Partial Paralysis
                50245, //Pin (Crab)
                91807, //Shambling Rush (Dark Transformation)
                123407, //Spinning Fire Blossom
                107566, //Staggering Shout
                54706, //Venom Web Spray (Silithid)
                114404, //Void Tendril's Grasp
                4167, //Web (Spider)
            };


        private static readonly string[] SoulSwapDebuffs = new[]
            {
                "Rake",
                "Rip"
            };

        #endregion

        #region Nested type: shadow_dance

        public class shadow_dance
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(51713); }
            }

            public static double remains
            {
                get { return StyxWoW.Me.HasAura(51713) ? StyxWoW.Me.GetAuraById(51713).TimeLeft.TotalSeconds : 0; }
            }
        }

        #endregion

        #region Nested type: slice_and_dice

        public class slice_and_dice
        {
            public static double remains
            {
                get { return StyxWoW.Me.HasAura(5171) ? StyxWoW.Me.GetAuraById(5171).TimeLeft.TotalSeconds : 0; }
            }
        }

        #endregion

        #region Nested type: stealthed

        public class stealthed
        {
            public static bool down
            {
                get { return !StyxWoW.Me.HasAura(115191); }
            }

            public static bool up
            {
                get { return StyxWoW.Me.HasAura(115191); }
            }
        }

        #endregion

        #region Nested type: vanish

        public class vanish
        {
            public static bool up
            {
                get { return StyxWoW.Me.HasAura(115193); }
            }
        }

        #endregion
    }
}